/******************************************************************************
 *
 * Copyright(c) 2020 Realtek Corporation.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 *****************************************************************************/
#include "phl_headers.h"
#include "phl_country.h"

const struct country_domain_mapping cdmap[MAX_COUNTRY_NUM] = {
    {0x4d, {'A', 'R'}, TPO_NA, 0x0f}, /* 0000 */
    {0x61, {'B', 'O'}, TPO_NA, 0x0f}, /* 0001 */
    {0x62, {'B', 'R'}, TPO_NA, 0x0f}, /* 0002 */
    {0x76, {'C', 'L'}, TPO_CHILE, 0x0f}, /* 0003 */
    {0x76, {'C', 'O'}, TPO_NA, 0x0f}, /* 0004 */
    {0x76, {'C', 'R'}, TPO_NA, 0x0f}, /* 0005 */
    {0x76, {'E', 'C'}, TPO_NA, 0x0f}, /* 0006 */
    {0x76, {'S', 'V'}, TPO_NA, 0x0f}, /* 0007 */
    {0x76, {'G', 'T'}, TPO_NA, 0x0f}, /* 0008 */
    {0x32, {'H', 'N'}, TPO_NA, 0x0f}, /* 0009 */
    {0x4d, {'M', 'X'}, TPO_NA, 0x0f}, /* 0010 */
    {0x76, {'N', 'I'}, TPO_NA, 0x0f}, /* 0011 */
    {0x76, {'P', 'A'}, TPO_NA, 0x0f}, /* 0012 */
    {0x76, {'P', 'Y'}, TPO_NA, 0x0f}, /* 0013 */
    {0x76, {'P', 'E'}, TPO_NA, 0x0f}, /* 0014 */
    {0x76, {'U', 'S'}, TPO_NA, 0x0f}, /* 0015 */
    {0x30, {'U', 'Y'}, TPO_NA, 0x0f}, /* 0016 */
    {0x30, {'V', 'E'}, TPO_NA, 0x0f}, /* 0017 */
    {0x76, {'P', 'R'}, TPO_NA, 0x0f}, /* 0018 */
    {0x76, {'D', 'O'}, TPO_NA, 0x0f}, /* 0019 */
    {0x5e, {'A', 'T'}, TPO_NA, 0x0f}, /* 0020 */
    {0x5e, {'B', 'E'}, TPO_NA, 0x0f}, /* 0021 */
    {0x5e, {'C', 'Y'}, TPO_NA, 0x0f}, /* 0022 */
    {0x5e, {'C', 'Z'}, TPO_NA, 0x0f}, /* 0023 */
    {0x5e, {'D', 'K'}, TPO_NA, 0x0f}, /* 0024 */
    {0x5e, {'E', 'E'}, TPO_NA, 0x0f}, /* 0025 */
    {0x5e, {'F', 'I'}, TPO_NA, 0x0f}, /* 0026 */
    {0x5e, {'F', 'R'}, TPO_NA, 0x0f}, /* 0027 */
    {0x5e, {'D', 'E'}, TPO_NA, 0x0f}, /* 0028 */
    {0x5e, {'G', 'R'}, TPO_NA, 0x0f}, /* 0029 */
    {0x5e, {'H', 'U'}, TPO_NA, 0x0f}, /* 0030 */
    {0x5e, {'I', 'S'}, TPO_NA, 0x0f}, /* 0031 */
    {0x5e, {'I', 'E'}, TPO_NA, 0x0f}, /* 0032 */
    {0x5e, {'I', 'T'}, TPO_NA, 0x0f}, /* 0033 */
    {0x5e, {'L', 'V'}, TPO_NA, 0x0f}, /* 0034 */
    {0x5e, {'L', 'I'}, TPO_NA, 0x0f}, /* 0035 */
    {0x5e, {'L', 'T'}, TPO_NA, 0x0f}, /* 0036 */
    {0x5e, {'L', 'U'}, TPO_NA, 0x0f}, /* 0037 */
    {0x5e, {'M', 'T'}, TPO_NA, 0x0f}, /* 0038 */
    {0x5e, {'M', 'C'}, TPO_NA, 0x0f}, /* 0039 */
    {0x5e, {'N', 'L'}, TPO_NA, 0x0f}, /* 0040 */
    {0x5e, {'N', 'O'}, TPO_NA, 0x0f}, /* 0041 */
    {0x5e, {'P', 'L'}, TPO_NA, 0x0f}, /* 0042 */
    {0x5e, {'P', 'T'}, TPO_NA, 0x0f}, /* 0043 */
    {0x5e, {'S', 'K'}, TPO_NA, 0x0f}, /* 0044 */
    {0x5e, {'S', 'I'}, TPO_NA, 0x0f}, /* 0045 */
    {0x5e, {'E', 'S'}, TPO_NA, 0x0f}, /* 0046 */
    {0x5e, {'S', 'E'}, TPO_NA, 0x0f}, /* 0047 */
    {0x5e, {'C', 'H'}, TPO_NA, 0x0f}, /* 0048 */
    {0x5e, {'G', 'B'}, TPO_NA, 0x0f}, /* 0049 */
    {0x5e, {'A', 'L'}, TPO_NA, 0x0f}, /* 0050 */
    {0x5e, {'A', 'Z'}, TPO_NA, 0x0f}, /* 0051 */
    {0x06, {'B', 'H'}, TPO_NA, 0x0f}, /* 0052 */
    {0x5e, {'B', 'A'}, TPO_NA, 0x0f}, /* 0053 */
    {0x5e, {'B', 'G'}, TPO_NA, 0x0f}, /* 0054 */
    {0x5e, {'H', 'R'}, TPO_NA, 0x0f}, /* 0055 */
    {0x3c, {'E', 'G'}, TPO_NA, 0x0f}, /* 0056 */
    {0x5e, {'G', 'H'}, TPO_NA, 0x0f}, /* 0057 */
    {0x05, {'I', 'Q'}, TPO_NA, 0x0f}, /* 0058 */
    {0x5e, {'I', 'L'}, TPO_NA, 0x0f}, /* 0059 */
    {0x05, {'J', 'O'}, TPO_NA, 0x0f}, /* 0060 */
    {0x5e, {'K', 'Z'}, TPO_NA, 0x0f}, /* 0061 */
    {0x5e, {'K', 'E'}, TPO_NA, 0x0f}, /* 0062 */
    {0x5e, {'K', 'W'}, TPO_NA, 0x0f}, /* 0063 */
    {0x5e, {'K', 'G'}, TPO_NA, 0x0f}, /* 0064 */
    {0x5e, {'L', 'B'}, TPO_NA, 0x0f}, /* 0065 */
    {0x5e, {'L', 'S'}, TPO_NA, 0x0f}, /* 0066 */
    {0x3a, {'M', 'K'}, TPO_NA, 0x0f}, /* 0067 */
    {0x3c, {'M', 'A'}, TPO_NA, 0x0f}, /* 0068 */
    {0x5e, {'M', 'Z'}, TPO_NA, 0x0f}, /* 0069 */
    {0x5e, {'N', 'A'}, TPO_NA, 0x0f}, /* 0070 */
    {0x75, {'N', 'G'}, TPO_NA, 0x0f}, /* 0071 */
    {0x5e, {'O', 'M'}, TPO_NA, 0x0f}, /* 0072 */
    {0x5e, {'Q', 'A'}, TPO_QATAR, 0x0f}, /* 0073 */
    {0x5e, {'R', 'O'}, TPO_NA, 0x0f}, /* 0074 */
    {0x09, {'R', 'U'}, TPO_NA, 0x0f}, /* 0075 */
    {0x5e, {'S', 'A'}, TPO_NA, 0x0f}, /* 0076 */
    {0x3a, {'S', 'N'}, TPO_NA, 0x0f}, /* 0077 */
    {0x5e, {'R', 'S'}, TPO_NA, 0x0f}, /* 0078 */
    {0x3a, {'M', 'E'}, TPO_NA, 0x0f}, /* 0079 */
    {0x5e, {'Z', 'A'}, TPO_NA, 0x0f}, /* 0080 */
    {0x5e, {'T', 'R'}, TPO_NA, 0x0f}, /* 0081 */
    {0x5e, {'U', 'A'}, TPO_UKRAINE, 0x0f}, /* 0082 */
    {0x5e, {'A', 'E'}, TPO_NA, 0x0f}, /* 0083 */
    {0x3a, {'Y', 'E'}, TPO_NA, 0x0f}, /* 0084 */
    {0x5e, {'Z', 'W'}, TPO_NA, 0x0f}, /* 0085 */
    {0x5e, {'B', 'D'}, TPO_NA, 0x0f}, /* 0086 */
    {0x5e, {'K', 'H'}, TPO_NA, 0x0f}, /* 0087 */
    {0x06, {'C', 'N'}, TPO_CN, 0x0f}, /* 0088 */
    {0x5e, {'H', 'K'}, TPO_NA, 0x0f}, /* 0089 */
    {0x06, {'I', 'N'}, TPO_NA, 0x0f}, /* 0090 */
    {0x5d, {'I', 'D'}, TPO_NA, 0x0f}, /* 0091 */
    {0x4b, {'K', 'R'}, TPO_NA, 0x0f}, /* 0092 */
    {0x07, {'M', 'Y'}, TPO_NA, 0x0f}, /* 0093 */
    {0x51, {'P', 'K'}, TPO_NA, 0x0f}, /* 0094 */
    {0x5e, {'P', 'H'}, TPO_NA, 0x0f}, /* 0095 */
    {0x5e, {'S', 'G'}, TPO_NA, 0x0f}, /* 0096 */
    {0x5e, {'L', 'K'}, TPO_NA, 0x0f}, /* 0097 */
    {0x76, {'T', 'W'}, TPO_NA, 0x0f}, /* 0098 */
    {0x5e, {'T', 'H'}, TPO_NA, 0x0f}, /* 0099 */
    {0x5e, {'V', 'N'}, TPO_NA, 0x0f}, /* 0100 */
    {0x03, {'A', 'U'}, TPO_NA, 0x0f}, /* 0101 */
    {0x03, {'N', 'Z'}, TPO_NA, 0x0f}, /* 0102 */
    {0x5e, {'P', 'G'}, TPO_NA, 0x0f}, /* 0103 */
    {0x2b, {'C', 'A'}, TPO_NA, 0x0f}, /* 0104 */
    {0x7d, {'J', 'P'}, TPO_NA, 0x0f}, /* 0105 */
    {0x76, {'J', 'M'}, TPO_NA, 0x0f}, /* 0106 */
    {0x76, {'A', 'N'}, TPO_NA, 0x0f}, /* 0107 */
    {0x76, {'T', 'T'}, TPO_NA, 0x0f}, /* 0108 */
    {0x04, {'T', 'N'}, TPO_NA, 0x0f}, /* 0109 */
    {0x42, {'A', 'F'}, TPO_NA, 0x0f}, /* 0110 */
    {0x00, {'D', 'Z'}, TPO_NA, 0x0f}, /* 0111 */
    {0x76, {'A', 'S'}, TPO_NA, 0x0f}, /* 0112 */
    {0x3a, {'A', 'D'}, TPO_NA, 0x0f}, /* 0113 */
    {0x5e, {'A', 'O'}, TPO_NA, 0x0f}, /* 0114 */
    {0x5e, {'A', 'I'}, TPO_NA, 0x0f}, /* 0115 */
    {0x26, {'A', 'Q'}, TPO_NA, 0x0f}, /* 0116 */
    {0x76, {'A', 'G'}, TPO_NA, 0x0f}, /* 0117 */
    {0x5e, {'A', 'M'}, TPO_NA, 0x0f}, /* 0118 */
    {0x76, {'A', 'W'}, TPO_NA, 0x0f}, /* 0119 */
    {0x76, {'B', 'S'}, TPO_NA, 0x0f}, /* 0120 */
    {0x76, {'B', 'B'}, TPO_NA, 0x0f}, /* 0121 */
    {0x08, {'B', 'Y'}, TPO_NA, 0x07}, /* 0122 */
    {0x76, {'B', 'Z'}, TPO_NA, 0x0f}, /* 0123 */
    {0x3a, {'B', 'J'}, TPO_NA, 0x0f}, /* 0124 */
    {0x76, {'B', 'M'}, TPO_NA, 0x0f}, /* 0125 */
    {0x5e, {'B', 'T'}, TPO_NA, 0x0f}, /* 0126 */
    {0x5e, {'B', 'W'}, TPO_NA, 0x0f}, /* 0127 */
    {0x5e, {'B', 'V'}, TPO_NA, 0x0f}, /* 0128 */
    {0x3a, {'I', 'O'}, TPO_NA, 0x0f}, /* 0129 */
    {0x76, {'V', 'G'}, TPO_NA, 0x0f}, /* 0130 */
    {0x06, {'B', 'N'}, TPO_NA, 0x0f}, /* 0131 */
    {0x5e, {'B', 'F'}, TPO_NA, 0x0f}, /* 0132 */
    {0x3a, {'M', 'M'}, TPO_NA, 0x0f}, /* 0133 */
    {0x3a, {'B', 'I'}, TPO_NA, 0x0f}, /* 0134 */
    {0x5e, {'C', 'M'}, TPO_NA, 0x0f}, /* 0135 */
    {0x5e, {'C', 'V'}, TPO_NA, 0x0f}, /* 0136 */
    {0x76, {'K', 'Y'}, TPO_NA, 0x0f}, /* 0137 */
    {0x3a, {'C', 'F'}, TPO_NA, 0x0f}, /* 0138 */
    {0x3a, {'T', 'D'}, TPO_NA, 0x0f}, /* 0139 */
    {0x03, {'C', 'X'}, TPO_NA, 0x0f}, /* 0140 */
    {0x3a, {'C', 'C'}, TPO_NA, 0x0f}, /* 0141 */
    {0x3a, {'K', 'M'}, TPO_NA, 0x0f}, /* 0142 */
    {0x3a, {'C', 'G'}, TPO_NA, 0x0f}, /* 0143 */
    {0x3a, {'C', 'D'}, TPO_NA, 0x0f}, /* 0144 */
    {0x5e, {'C', 'K'}, TPO_NA, 0x0f}, /* 0145 */
    {0x42, {'C', 'I'}, TPO_NA, 0x0f}, /* 0146 */
    {0x3a, {'D', 'J'}, TPO_NA, 0x0f}, /* 0147 */
    {0x76, {'D', 'M'}, TPO_NA, 0x0f}, /* 0148 */
    {0x5e, {'G', 'Q'}, TPO_NA, 0x0f}, /* 0149 */
    {0x3a, {'E', 'R'}, TPO_NA, 0x0f}, /* 0150 */
    {0x3a, {'E', 'T'}, TPO_NA, 0x0f}, /* 0151 */
    {0x3a, {'F', 'K'}, TPO_NA, 0x0f}, /* 0152 */
    {0x3a, {'F', 'O'}, TPO_NA, 0x0f}, /* 0153 */
    {0x76, {'F', 'J'}, TPO_NA, 0x0f}, /* 0154 */
    {0x3a, {'G', 'F'}, TPO_NA, 0x0f}, /* 0155 */
    {0x3a, {'P', 'F'}, TPO_NA, 0x0f}, /* 0156 */
    {0x3a, {'T', 'F'}, TPO_NA, 0x0f}, /* 0157 */
    {0x5e, {'G', 'A'}, TPO_NA, 0x0f}, /* 0158 */
    {0x3a, {'G', 'M'}, TPO_NA, 0x0f}, /* 0159 */
    {0x5e, {'G', 'E'}, TPO_NA, 0x0f}, /* 0160 */
    {0x3a, {'G', 'I'}, TPO_NA, 0x0f}, /* 0161 */
    {0x5e, {'G', 'L'}, TPO_NA, 0x0f}, /* 0162 */
    {0x76, {'G', 'D'}, TPO_NA, 0x0f}, /* 0163 */
    {0x3a, {'G', 'P'}, TPO_NA, 0x0f}, /* 0164 */
    {0x76, {'G', 'U'}, TPO_NA, 0x0f}, /* 0165 */
    {0x5e, {'G', 'G'}, TPO_NA, 0x0f}, /* 0166 */
    {0x3a, {'G', 'N'}, TPO_NA, 0x0f}, /* 0167 */
    {0x3a, {'G', 'W'}, TPO_NA, 0x0f}, /* 0168 */
    {0x44, {'G', 'Y'}, TPO_NA, 0x0f}, /* 0169 */
    {0x76, {'H', 'T'}, TPO_NA, 0x07}, /* 0170 */
    {0x03, {'H', 'M'}, TPO_NA, 0x0f}, /* 0171 */
    {0x3a, {'V', 'A'}, TPO_NA, 0x0f}, /* 0172 */
    {0x3a, {'I', 'M'}, TPO_NA, 0x0f}, /* 0173 */
    {0x3a, {'J', 'E'}, TPO_NA, 0x0f}, /* 0174 */
    {0x5e, {'K', 'I'}, TPO_NA, 0x0f}, /* 0175 */
    {0x5e, {'L', 'A'}, TPO_NA, 0x0f}, /* 0176 */
    {0x5e, {'L', 'R'}, TPO_NA, 0x0f}, /* 0177 */
    {0x5e, {'L', 'Y'}, TPO_NA, 0x0f}, /* 0178 */
    {0x5e, {'M', 'O'}, TPO_NA, 0x0f}, /* 0179 */
    {0x5e, {'M', 'G'}, TPO_NA, 0x0f}, /* 0180 */
    {0x5e, {'M', 'W'}, TPO_NA, 0x0f}, /* 0181 */
    {0x3c, {'M', 'V'}, TPO_NA, 0x0f}, /* 0182 */
    {0x5e, {'M', 'L'}, TPO_NA, 0x0f}, /* 0183 */
    {0x76, {'M', 'H'}, TPO_NA, 0x0f}, /* 0184 */
    {0x3a, {'M', 'Q'}, TPO_NA, 0x0f}, /* 0185 */
    {0x5e, {'M', 'R'}, TPO_NA, 0x0f}, /* 0186 */
    {0x5e, {'M', 'U'}, TPO_NA, 0x0f}, /* 0187 */
    {0x5e, {'Y', 'T'}, TPO_NA, 0x0f}, /* 0188 */
    {0x76, {'F', 'M'}, TPO_NA, 0x0f}, /* 0189 */
    {0x5e, {'M', 'D'}, TPO_NA, 0x0f}, /* 0190 */
    {0x5e, {'M', 'N'}, TPO_NA, 0x0f}, /* 0191 */
    {0x3a, {'M', 'S'}, TPO_NA, 0x0f}, /* 0192 */
    {0x3a, {'N', 'R'}, TPO_NA, 0x0f}, /* 0193 */
    {0x06, {'N', 'P'}, TPO_NA, 0x0f}, /* 0194 */
    {0x3a, {'N', 'C'}, TPO_NA, 0x0f}, /* 0195 */
    {0x5e, {'N', 'E'}, TPO_NA, 0x0f}, /* 0196 */
    {0x03, {'N', 'U'}, TPO_NA, 0x0f}, /* 0197 */
    {0x03, {'N', 'F'}, TPO_NA, 0x0f}, /* 0198 */
    {0x76, {'M', 'P'}, TPO_NA, 0x0f}, /* 0199 */
    {0x76, {'P', 'W'}, TPO_NA, 0x0f}, /* 0200 */
    {0x3a, {'R', 'E'}, TPO_NA, 0x0f}, /* 0201 */
    {0x5e, {'R', 'W'}, TPO_NA, 0x0f}, /* 0202 */
    {0x3a, {'S', 'H'}, TPO_NA, 0x0f}, /* 0203 */
    {0x76, {'K', 'N'}, TPO_NA, 0x0f}, /* 0204 */
    {0x76, {'L', 'C'}, TPO_NA, 0x0f}, /* 0205 */
    {0x76, {'M', 'F'}, TPO_NA, 0x0f}, /* 0206 */
    {0x76, {'S', 'X'}, TPO_NA, 0x0f}, /* 0207 */
    {0x3a, {'P', 'M'}, TPO_NA, 0x0f}, /* 0208 */
    {0x76, {'V', 'C'}, TPO_NA, 0x0f}, /* 0209 */
    {0x76, {'W', 'S'}, TPO_NA, 0x0f}, /* 0210 */
    {0x3a, {'S', 'M'}, TPO_NA, 0x0f}, /* 0211 */
    {0x76, {'S', 'T'}, TPO_NA, 0x0f}, /* 0212 */
    {0x76, {'S', 'C'}, TPO_NA, 0x0f}, /* 0213 */
    {0x5e, {'S', 'L'}, TPO_NA, 0x0f}, /* 0214 */
    {0x3a, {'S', 'B'}, TPO_NA, 0x0f}, /* 0215 */
    {0x3a, {'S', 'O'}, TPO_NA, 0x0f}, /* 0216 */
    {0x3a, {'G', 'S'}, TPO_NA, 0x0f}, /* 0217 */
    {0x74, {'S', 'R'}, TPO_NA, 0x0f}, /* 0218 */
    {0x3a, {'S', 'J'}, TPO_NA, 0x0f}, /* 0219 */
    {0x5e, {'S', 'Z'}, TPO_NA, 0x0f}, /* 0220 */
    {0x5e, {'T', 'J'}, TPO_NA, 0x0f}, /* 0221 */
    {0x5e, {'T', 'Z'}, TPO_NA, 0x0f}, /* 0222 */
    {0x5e, {'T', 'G'}, TPO_NA, 0x0f}, /* 0223 */
    {0x03, {'T', 'K'}, TPO_NA, 0x0f}, /* 0224 */
    {0x3a, {'T', 'O'}, TPO_NA, 0x0f}, /* 0225 */
    {0x3a, {'T', 'M'}, TPO_NA, 0x0f}, /* 0226 */
    {0x3a, {'T', 'C'}, TPO_NA, 0x0f}, /* 0227 */
    {0x21, {'T', 'V'}, TPO_NA, 0x01}, /* 0228 */
    {0x3a, {'U', 'G'}, TPO_NA, 0x0f}, /* 0229 */
    {0x76, {'V', 'I'}, TPO_NA, 0x0f}, /* 0230 */
    {0x3c, {'U', 'Z'}, TPO_NA, 0x0f}, /* 0231 */
    {0x26, {'V', 'U'}, TPO_NA, 0x0f}, /* 0232 */
    {0x3a, {'W', 'F'}, TPO_NA, 0x0f}, /* 0233 */
    {0x3c, {'E', 'H'}, TPO_NA, 0x0f}, /* 0234 */
    {0x5e, {'Z', 'M'}, TPO_NA, 0x0f}, /* 0235 */
    {0x3a, {'I', 'R'}, TPO_NA, 0x01}, /* 0236 */
};



