/******************************************************************************
 *
 * Copyright(c) 2007 - 2020  Realtek Corporation.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * The full GNU General Public License is included in this distribution in the
 * file called LICENSE.
 *
 * Contact Information:
 * wlanfae <wlanfae@realtek.com>
 * Realtek Corporation, No. 2, Innovation Road II, Hsinchu Science Park,
 * Hsinchu 300, Taiwan.
 *
 * Larry Finger <Larry.Finger@lwfinger.net>
 *
 *****************************************************************************/

/*Image2HeaderVersion: R3 2.0.1.3*/
#ifndef _HALRF_HWIMG_RAW_DATA_8852A_H
#define _HALRF_HWIMG_RAW_DATA_8852A_H

#define D_S_SIZE DELTA_SWINGIDX_SIZE
#define D_ST_SIZE DELTA_SWINTSSI_SIZE


#if 0
/* Please put following enum definitions in appropriate header file. */
enum odm_pw_byrate_para_type {
	PW_BYRATE_PARA_NSS1,
	PW_BYRATE_PARA_NSS2,
	PW_BYRATE_PARA_OFFS = 0xF
};

enum odm_pw_byrate_rate_type {
	PW_BYRATE_RATE_11M_1M,
	PW_BYRATE_RATE_18M_6M,
	PW_BYRATE_RATE_54M_24M,
	PW_BYRATE_RATE_MCS3_0,
	PW_BYRATE_RATE_MCS7_4,
	PW_BYRATE_RATE_MCS11_8,
	PW_BYRATE_RATE_DCM4_0,
	PW_BYRATE_RATE_AllRate2_1,  /* CCK, OFDM, HT, VHT */
	PW_BYRATE_RATE_AllRate2_2,  /* HE_HEDCM */
	PW_BYRATE_RATE_AllRate5_1,  /* OFDM, HT, VHT, HE_HEDCM */
	PW_BYRATE_RATE_NULL = 0xF
};

enum odm_pw_lmt_regulation_type {
	PW_LMT_REGU_FCC,
	PW_LMT_REGU_ETSI,
	PW_LMT_REGU_MKK,
	PW_LMT_REGU_IC,
	PW_LMT_REGU_KCC,
	PW_LMT_REGU_ACMA,
	PW_LMT_REGU_CHILE,
	PW_LMT_REGU_UKRAINE,
	PW_LMT_REGU_MEXICO,
	PW_LMT_REGU_CN,
	PW_LMT_REGU_WW13,
	PW_LMT_REGU_NULL
};

enum odm_pw_lmt_band_type {
	PW_LMT_BAND_2_4G,
	PW_LMT_BAND_5G,
	PW_LMT_BAND_NULL
};

enum odm_pw_lmt_bandwidth_type {
	PW_LMT_BW_20M,
	PW_LMT_BW_40M,
	PW_LMT_BW_80M,
	PW_LMT_BW_NULL
};

enum odm_pw_lmt_ru_bandwidth_type {
	PW_LMT_RU_BW_RU26,
	PW_LMT_RU_BW_RU52,
	PW_LMT_RU_BW_RU106,
	PW_LMT_RU_BW_NULL
};

enum odm_pw_lmt_ratesection_type {
	PW_LMT_RS_CCK,
	PW_LMT_RS_OFDM,
	PW_LMT_RS_HT,
	PW_LMT_RS_VHT,
	PW_LMT_RS_HE,
	PW_LMT_RS_NULL
};

enum odm_pw_lmt_beamform_type {
	PW_LMT_BF,
	PW_LMT_NONBF,
	PW_LMT_NULL
};

enum odm_pw_lmt_rfpath_type {
	PW_LMT_PH_1T,
	PW_LMT_PH_2T,
	PW_LMT_PH_3T,
	PW_LMT_PH_4T,
	PW_LMT_PH_NULL
};

struct halrf_tx_pw_lmt {
	u8			band:1;
	u8			bw:3;
	u8			rs:2;
	u8			ntx:2;
	u8			bf:3;
	u8			reg:5;
	u8			ch;
	s8			val;
};

struct halrf_tx_pw_lmt_ru {
	u8			band:1;
	u8			bw:2;
	u8			ntx:2;
	u8			rs:3;
	u8			reg;
	u8			ch;
	s8			val;
};
#endif


/******************************************************************************
 *                           radioa.TXT
 ******************************************************************************/

const u32 array_mp_8852a_radioa[] = {
		0xF0010000, 0x00000000,
		0xF0010001, 0x00000001,
		0xF0020001, 0x00000002,
		0xF0030001, 0x00000003,
		0xF0250001, 0x00000004,
		0xF0260001, 0x00000005,
		0xF0320001, 0x00000006,
		0xF0330001, 0x00000007,
		0xF0340001, 0x00000008,
		0xF0350001, 0x00000009,
		0xF0360001, 0x0000000A,
		0xF0010002, 0x0000000B,
		0xF0020002, 0x0000000C,
		0xF0030002, 0x0000000D,
		0xF0250002, 0x0000000E,
		0xF0260002, 0x0000000F,
		0xF0320002, 0x00000010,
		0xF0330002, 0x00000011,
		0xF0340002, 0x00000012,
		0xF0350002, 0x00000013,
		0xF0360002, 0x00000014,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000001,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0xA0000000,	0x00000000,
		0x005, 0x00000001,
	0xB0000000,	0x00000000,
		0x000, 0x00030000,
		0x018, 0x00011124,
		0x000, 0x00033C00,
		0x01A, 0x00040004,
		0x0FE, 0x00000000,
		0x055, 0x00080000,
		0x056, 0x0008FFF0,
		0x057, 0x0000C485,
		0x058, 0x000A4164,
		0x059, 0x00010000,
		0x05A, 0x00060000,
		0x05B, 0x0000A000,
		0x05C, 0x00000000,
		0x05D, 0x0001C013,
		0x05E, 0x00000000,
		0x05F, 0x00001FF0,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011000,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0xA0000000,	0x00000000,
		0x060, 0x00011000,
	0xB0000000,	0x00000000,
		0x061, 0x0009F338,
		0x062, 0x0009233A,
		0x063, 0x000D6002,
		0x064, 0x000A0CB0,
		0x065, 0x00030EFE,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0xA0000000,	0x00000000,
		0x066, 0x00020000,
	0xB0000000,	0x00000000,
		0x068, 0x00000000,
		0x069, 0x00030F0A,
		0x06A, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000AD6A4,
		0x052, 0x00091345,
		0x053, 0x00080081,
		0x054, 0x0009BC24,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0xA0000000,	0x00000000,
		0x051, 0x000AD6A4,
		0x052, 0x00091345,
		0x053, 0x00080081,
		0x054, 0x0009BC24,
	0xB0000000,	0x00000000,
		0x0D3, 0x00000143,
		0x043, 0x00005000,
		0x0DD, 0x000003A0,
		0x0B0, 0x000E6700,
		0x0AF, 0x0001F82E,
		0x0B2, 0x000210A7,
		0x0B1, 0x00065FFF,
		0x0BB, 0x000F7A00,
		0x0B3, 0x00013F7A,
		0x0D4, 0x0000000E,
		0x0B7, 0x00001E0C,
		0x0A0, 0x0000004F,
		0x0B4, 0x0007C03E,
		0x0B5, 0x0007E301,
		0x0B6, 0x00080800,
		0x0CA, 0x00002000,
		0x0DD, 0x000003A0,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x00080000,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0xA0000000,	0x00000000,
		0x0CC, 0x00080000,
	0xB0000000,	0x00000000,
		0x0A1, 0x0006F300,
		0x0A2, 0x00080500,
		0x0A3, 0x0008050B,
		0x0A4, 0x0006DB12,
		0x0A5, 0x00000000,
		0x0A6, 0x00000000,
		0x0A7, 0x00000000,
		0x0A8, 0x00000000,
		0x0A9, 0x00000000,
		0x0AA, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x000B0000,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0xA0000000,	0x00000000,
		0x0A5, 0x000B0000,
	0xB0000000,	0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00008000,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0xA0000000,	0x00000000,
		0x0ED, 0x00008000,
	0xB0000000,	0x00000000,
		0x033, 0x00000000,
		0x03E, 0x00008000,
		0x03F, 0x000E1333,
		0x033, 0x00000001,
		0x03E, 0x00008000,
		0x03F, 0x000E7333,
		0x033, 0x00000002,
		0x03E, 0x00008000,
		0x03F, 0x000FA000,
		0x033, 0x00000003,
		0x03E, 0x00004000,
		0x03F, 0x000FA400,
		0x033, 0x00000004,
		0x03E, 0x00004000,
		0x03F, 0x000F5000,
		0x033, 0x00000005,
		0x03E, 0x00004001,
		0x03F, 0x00029400,
		0x033, 0x00000006,
		0x03E, 0x0000AAA1,
		0x03F, 0x00041999,
		0x033, 0x00000007,
		0x03E, 0x0000AAA1,
		0x03F, 0x00034444,
		0x033, 0x00000008,
		0x03E, 0x0000AAA1,
		0x03F, 0x0004D555,
		0x033, 0x00000009,
		0x03E, 0x00005551,
		0x03F, 0x00046AAA,
		0x033, 0x0000000A,
		0x03E, 0x00005551,
		0x03F, 0x00046AAA,
		0x033, 0x0000000B,
		0x03E, 0x00005551,
		0x03F, 0x0008C555,
		0x033, 0x0000000C,
		0x03E, 0x0000CCC1,
		0x03F, 0x00081EB8,
		0x033, 0x0000000D,
		0x03E, 0x0000CCC1,
		0x03F, 0x00071EB8,
		0x033, 0x0000000E,
		0x03E, 0x0000CCC1,
		0x03F, 0x00090000,
		0x033, 0x0000000F,
		0x03E, 0x00006661,
		0x03F, 0x00088000,
		0x033, 0x00000010,
		0x03E, 0x00006661,
		0x03F, 0x00088000,
		0x033, 0x00000011,
		0x03E, 0x00006661,
		0x03F, 0x000DB999,
		0x0ED, 0x00000000,
		0x0ED, 0x00002000,
		0x033, 0x00000002,
		0x03D, 0x0004A883,
		0x03E, 0x00000000,
		0x03F, 0x00000001,
		0x033, 0x00000006,
		0x03D, 0x0004A883,
		0x03E, 0x00000000,
		0x03F, 0x00000001,
		0x0ED, 0x00000000,
		0x018, 0x00001001,
		0x002, 0x0000000D,
		0x0EE, 0x00000004,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0xA0000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0xB0000000,	0x00000000,
		0x0EE, 0x00000000,
		0x08F, 0x000D0F7A,
		0x08C, 0x00084584,
		0x0EF, 0x00004000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0xA0000000,	0x00000000,
		0x03F, 0x00000700,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0xA0000000,	0x00000000,
		0x03F, 0x00000700,
	0xB0000000,	0x00000000,
		0x033, 0x00000005,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000500,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0xA0000000,	0x00000000,
		0x03F, 0x00000500,
	0xB0000000,	0x00000000,
		0x033, 0x00000004,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0xA0000000,	0x00000000,
		0x03F, 0x00000400,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00008B00,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0xA0000000,	0x00000000,
		0x03F, 0x00008B00,
	0xB0000000,	0x00000000,
		0x033, 0x00000002,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0xA0000000,	0x00000000,
		0x03F, 0x00000B00,
	0xB0000000,	0x00000000,
		0x033, 0x00000001,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0xA0000000,	0x00000000,
		0x03F, 0x00001A00,
	0xB0000000,	0x00000000,
		0x033, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0xA0000000,	0x00000000,
		0x03F, 0x00002900,
	0xB0000000,	0x00000000,
		0x0EF, 0x00000000,
		0x0EF, 0x00001000,
		0x033, 0x00000000,
		0x03F, 0x00000015,
		0x033, 0x00000001,
		0x03F, 0x00000017,
		0x0EF, 0x00000000,
		0x0EF, 0x00008000,
		0x033, 0x00000000,
		0x03F, 0x000FECFC,
		0x033, 0x00000001,
		0x03F, 0x000BECFC,
		0x033, 0x00000002,
		0x03F, 0x0003E4FC,
		0x033, 0x00000003,
		0x03F, 0x0001D0FC,
		0x033, 0x00000004,
		0x03F, 0x0001C3FC,
		0x033, 0x00000005,
		0x03F, 0x000103FC,
		0x033, 0x00000006,
		0x03F, 0x0000007C,
		0x033, 0x00000007,
		0x03F, 0x0000007C,
		0x033, 0x00000008,
		0x03F, 0x000FECFC,
		0x033, 0x00000009,
		0x03F, 0x000BECFC,
		0x033, 0x0000000A,
		0x03F, 0x0003E4FC,
		0x033, 0x0000000B,
		0x03F, 0x0001D0FC,
		0x033, 0x0000000C,
		0x03F, 0x0001C3FC,
		0x033, 0x0000000D,
		0x03F, 0x000103FC,
		0x033, 0x0000000E,
		0x03F, 0x0000007C,
		0x033, 0x0000000F,
		0x03F, 0x0000007C,
		0x033, 0x00000010,
		0x03F, 0x000FECFC,
		0x033, 0x00000011,
		0x03F, 0x000BECFC,
		0x033, 0x00000012,
		0x03F, 0x0003E4FC,
		0x033, 0x00000013,
		0x03F, 0x0001D0FC,
		0x033, 0x00000014,
		0x03F, 0x0001C3FC,
		0x033, 0x00000015,
		0x03F, 0x000103FC,
		0x033, 0x00000016,
		0x03F, 0x0000007C,
		0x033, 0x00000017,
		0x03F, 0x0000007C,
		0x0EF, 0x00000000,
		0x0EF, 0x00000100,
		0x033, 0x00000000,
		0x03F, 0x00003317,
		0x033, 0x00000001,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000002,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000004,
		0x03F, 0x00003317,
		0x033, 0x00000005,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000008,
		0x03F, 0x00003317,
		0x033, 0x00000009,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x0000000A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0xA0000000,	0x00000000,
		0x03F, 0x00003336,
	0xB0000000,	0x00000000,
		0x033, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x0000000C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x0000000D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x0000000E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0xA0000000,	0x00000000,
		0x03F, 0x00003336,
	0xB0000000,	0x00000000,
		0x033, 0x0000000F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000010,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000011,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000012,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0xA0000000,	0x00000000,
		0x03F, 0x00003336,
	0xB0000000,	0x00000000,
		0x033, 0x00000013,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000014,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0xA0000000,	0x00000000,
		0x03F, 0x00003356,
	0xB0000000,	0x00000000,
		0x033, 0x00000015,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0xA0000000,	0x00000000,
		0x03F, 0x00003356,
	0xB0000000,	0x00000000,
		0x033, 0x00000016,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0xA0000000,	0x00000000,
		0x03F, 0x00003356,
	0xB0000000,	0x00000000,
		0x033, 0x00000017,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0xA0000000,	0x00000000,
		0x03F, 0x00003356,
	0xB0000000,	0x00000000,
		0x033, 0x00000018,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0xA0000000,	0x00000000,
		0x03F, 0x00003356,
	0xB0000000,	0x00000000,
		0x033, 0x00000019,
		0x03F, 0x00003338,
		0x033, 0x0000001A,
		0x03F, 0x00003338,
		0x033, 0x0000001B,
		0x03F, 0x00003338,
		0x033, 0x0000001C,
		0x03F, 0x00003338,
		0x033, 0x0000001D,
		0x03F, 0x00003338,
		0x033, 0x0000001E,
		0x03F, 0x00003338,
		0x033, 0x0000001F,
		0x03F, 0x00003338,
		0x033, 0x00000020,
		0x03F, 0x00003338,
		0x033, 0x00000021,
		0x03F, 0x00003338,
		0x033, 0x00000022,
		0x03F, 0x00003338,
		0x033, 0x00000023,
		0x03F, 0x00003338,
		0x033, 0x00000024,
		0x03F, 0x00003338,
		0x033, 0x00000025,
		0x03F, 0x00003338,
		0x033, 0x00000026,
		0x03F, 0x00003338,
		0x033, 0x00000027,
		0x03F, 0x00003338,
		0x033, 0x00000028,
		0x03F, 0x00003338,
		0x033, 0x00000029,
		0x03F, 0x00003338,
		0x033, 0x0000002A,
		0x03F, 0x00003338,
		0x033, 0x0000002B,
		0x03F, 0x00003338,
		0x033, 0x0000002C,
		0x03F, 0x00003338,
		0x033, 0x0000002D,
		0x03F, 0x00003338,
		0x033, 0x0000002E,
		0x03F, 0x00003338,
		0x033, 0x0000002F,
		0x03F, 0x00003338,
		0x033, 0x00000030,
		0x03F, 0x00003338,
		0x0EF, 0x00000000,
		0x0EF, 0x00000040,
		0x033, 0x00000001,
		0x03F, 0x000004BA,
		0x033, 0x00000002,
		0x03F, 0x000004BA,
		0x033, 0x00000003,
		0x03F, 0x000004BA,
		0x033, 0x00000004,
		0x03F, 0x000004BA,
		0x033, 0x00000005,
		0x03F, 0x000004BA,
		0x033, 0x00000006,
		0x03F, 0x000004BA,
		0x033, 0x00000007,
		0x03F, 0x000004BA,
		0x033, 0x00000008,
		0x03F, 0x000004BA,
		0x033, 0x00000009,
		0x03F, 0x000004BA,
		0x033, 0x0000000A,
		0x03F, 0x000004BA,
		0x033, 0x0000000B,
		0x03F, 0x000004BA,
		0x0EF, 0x00000000,
		0x0EF, 0x00000010,
		0x033, 0x00000001,
		0x03F, 0x00000CB0,
		0x033, 0x00000002,
		0x03F, 0x00000CB0,
		0x033, 0x00000003,
		0x03F, 0x00000870,
		0x033, 0x00000004,
		0x03F, 0x00000870,
		0x033, 0x00000005,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0xA0000000,	0x00000000,
		0x03F, 0x00000430,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0xA0000000,	0x00000000,
		0x03F, 0x00000430,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
		0x03F, 0x00000CB0,
		0x033, 0x00000008,
		0x03F, 0x00000CB0,
		0x033, 0x00000009,
		0x03F, 0x00000870,
		0x033, 0x0000000A,
		0x03F, 0x00000870,
		0x033, 0x0000000B,
		0x03F, 0x00000430,
		0x033, 0x0000000C,
		0x03F, 0x00000430,
		0x033, 0x0000000D,
		0x03F, 0x00000000,
		0x033, 0x0000000E,
		0x03F, 0x00000000,
		0x0EF, 0x00000000,
		0x0EF, 0x00000080,
		0x033, 0x00000000,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03F, 0x00023458,
	0xB0000000,	0x00000000,
		0x033, 0x00000001,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03F, 0x00023458,
	0xB0000000,	0x00000000,
		0x033, 0x00000002,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002F358,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002F358,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023458,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023458,
	0xB0000000,	0x00000000,
		0x033, 0x00000004,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03F, 0x00023458,
	0xB0000000,	0x00000000,
		0x033, 0x00000005,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03F, 0x00023458,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023458,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023458,
	0xB0000000,	0x00000000,
		0x033, 0x00000008,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03F, 0x00023458,
	0xB0000000,	0x00000000,
		0x033, 0x00000009,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00023858,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000C,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000D,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x00000010,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x00000011,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x00000012,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x00000013,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x00000014,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x00000015,
		0x03E, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00023758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x00000016,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x00000017,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E358,
	0xB0000000,	0x00000000,
		0x033, 0x00000018,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000019,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002E758,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000020,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000021,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000022,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E258,
	0xB0000000,	0x00000000,
		0x033, 0x00000023,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000024,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000025,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000026,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000027,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000028,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000029,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000002A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002F458,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002F458,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000002B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000002C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000002D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002E658,
	0xB0000000,	0x00000000,
		0x033, 0x0000002E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x0000002F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x00000030,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x00000031,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x00000032,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x00000033,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x00000034,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x00000035,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x00000036,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x00000037,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x00000038,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x00000039,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x0000003A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x033, 0x0000003B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00027758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C758,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000E,
		0x03F, 0x0002F658,
	0xB0000000,	0x00000000,
		0x0EF, 0x00000000,
		0x0EE, 0x00002000,
		0x033, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000001,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000002,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x00000004,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x00000005,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0xA0000000,	0x00000000,
		0x03F, 0x000001EA,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AA,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A7,
	0xB0000000,	0x00000000,
		0x033, 0x00000008,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E8,
	0xB0000000,	0x00000000,
		0x033, 0x00000009,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E5,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E5,
	0xB0000000,	0x00000000,
		0x033, 0x0000000A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000068,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0xA0000000,	0x00000000,
		0x03F, 0x00000068,
	0xB0000000,	0x00000000,
		0x033, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000065,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x00000065,
	0xB0000000,	0x00000000,
		0x033, 0x0000000C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x00000062,
	0xB0000000,	0x00000000,
		0x033, 0x0000000D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005F,
	0xB0000000,	0x00000000,
		0x033, 0x0000000E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005C,
	0xB0000000,	0x00000000,
		0x033, 0x0000000F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x00000059,
	0xB0000000,	0x00000000,
		0x033, 0x00000010,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x00000056,
	0xB0000000,	0x00000000,
		0x033, 0x00000011,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F5,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F5,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F5,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F5,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000012,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F2,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F2,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F2,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F2,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000013,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000014,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x00000015,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x00000016,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001EA,
	0xB0000000,	0x00000000,
		0x033, 0x00000017,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A5,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A5,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A5,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A5,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A9,
	0xB0000000,	0x00000000,
		0x033, 0x00000018,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A2,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A2,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A2,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A2,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A6,
	0xB0000000,	0x00000000,
		0x033, 0x00000019,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E5,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E5,
	0xB0000000,	0x00000000,
		0x033, 0x0000001A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E2,
	0xB0000000,	0x00000000,
		0x033, 0x0000001B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000DF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000065,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000065,
	0xB0000000,	0x00000000,
		0x033, 0x0000001D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000062,
	0xB0000000,	0x00000000,
		0x033, 0x0000001E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005F,
	0xB0000000,	0x00000000,
		0x033, 0x0000001F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005C,
	0xB0000000,	0x00000000,
		0x033, 0x00000020,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000059,
	0xB0000000,	0x00000000,
		0x033, 0x00000021,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000053,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000053,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000053,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000053,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000056,
	0xB0000000,	0x00000000,
		0x033, 0x00000022,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000023,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000024,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000025,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x00000026,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x00000027,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001EA,
	0xB0000000,	0x00000000,
		0x033, 0x00000028,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A9,
	0xB0000000,	0x00000000,
		0x033, 0x00000029,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A6,
	0xB0000000,	0x00000000,
		0x033, 0x0000002A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E5,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E5,
	0xB0000000,	0x00000000,
		0x033, 0x0000002B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E2,
	0xB0000000,	0x00000000,
		0x033, 0x0000002C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000DF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000065,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000065,
	0xB0000000,	0x00000000,
		0x033, 0x0000002E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000062,
	0xB0000000,	0x00000000,
		0x033, 0x0000002F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005F,
	0xB0000000,	0x00000000,
		0x033, 0x00000030,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005C,
	0xB0000000,	0x00000000,
		0x033, 0x00000031,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000059,
	0xB0000000,	0x00000000,
		0x033, 0x00000032,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000056,
	0xB0000000,	0x00000000,
		0x033, 0x00000033,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000034,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000035,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000036,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x00000037,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x00000038,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001EA,
	0xB0000000,	0x00000000,
		0x033, 0x00000039,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A9,
	0xB0000000,	0x00000000,
		0x033, 0x0000003A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A6,
	0xB0000000,	0x00000000,
		0x033, 0x0000003B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E5,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E5,
	0xB0000000,	0x00000000,
		0x033, 0x0000003C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E2,
	0xB0000000,	0x00000000,
		0x033, 0x0000003D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000DF,
	0xB0000000,	0x00000000,
		0x033, 0x0000003E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000065,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000065,
	0xB0000000,	0x00000000,
		0x033, 0x0000003F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000062,
	0xB0000000,	0x00000000,
		0x033, 0x00000040,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005F,
	0xB0000000,	0x00000000,
		0x033, 0x00000041,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005C,
	0xB0000000,	0x00000000,
		0x033, 0x00000042,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000059,
	0xB0000000,	0x00000000,
		0x033, 0x00000043,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000056,
	0xB0000000,	0x00000000,
		0x033, 0x00000044,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FC,
	0xB0000000,	0x00000000,
		0x033, 0x00000045,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000046,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000047,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000048,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x00000049,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x0000004A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AC,
	0xB0000000,	0x00000000,
		0x033, 0x0000004B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AA,
	0xB0000000,	0x00000000,
		0x033, 0x0000004C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A7,
	0xB0000000,	0x00000000,
		0x033, 0x0000004D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A4,
	0xB0000000,	0x00000000,
		0x033, 0x0000004E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000006C,
	0xB0000000,	0x00000000,
		0x033, 0x0000004F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000069,
	0xB0000000,	0x00000000,
		0x033, 0x00000050,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000066,
	0xB0000000,	0x00000000,
		0x033, 0x00000051,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000063,
	0xB0000000,	0x00000000,
		0x033, 0x00000052,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000060,
	0xB0000000,	0x00000000,
		0x033, 0x00000053,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005D,
	0xB0000000,	0x00000000,
		0x033, 0x00000054,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005A,
	0xB0000000,	0x00000000,
		0x033, 0x00000055,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FC,
	0xB0000000,	0x00000000,
		0x033, 0x00000056,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000057,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000058,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000059,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x0000005A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x0000005B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AC,
	0xB0000000,	0x00000000,
		0x033, 0x0000005C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AA,
	0xB0000000,	0x00000000,
		0x033, 0x0000005D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A7,
	0xB0000000,	0x00000000,
		0x033, 0x0000005E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A4,
	0xB0000000,	0x00000000,
		0x033, 0x0000005F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000006C,
	0xB0000000,	0x00000000,
		0x033, 0x00000060,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000069,
	0xB0000000,	0x00000000,
		0x033, 0x00000061,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000066,
	0xB0000000,	0x00000000,
		0x033, 0x00000062,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000063,
	0xB0000000,	0x00000000,
		0x033, 0x00000063,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000060,
	0xB0000000,	0x00000000,
		0x033, 0x00000064,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005D,
	0xB0000000,	0x00000000,
		0x033, 0x00000065,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005A,
	0xB0000000,	0x00000000,
		0x033, 0x00000066,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FC,
	0xB0000000,	0x00000000,
		0x033, 0x00000067,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000068,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000069,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x0000006A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x0000006B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x0000006C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AC,
	0xB0000000,	0x00000000,
		0x033, 0x0000006D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AA,
	0xB0000000,	0x00000000,
		0x033, 0x0000006E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A7,
	0xB0000000,	0x00000000,
		0x033, 0x0000006F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A4,
	0xB0000000,	0x00000000,
		0x033, 0x00000070,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000006C,
	0xB0000000,	0x00000000,
		0x033, 0x00000071,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000069,
	0xB0000000,	0x00000000,
		0x033, 0x00000072,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000066,
	0xB0000000,	0x00000000,
		0x033, 0x00000073,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000063,
	0xB0000000,	0x00000000,
		0x033, 0x00000074,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000060,
	0xB0000000,	0x00000000,
		0x033, 0x00000075,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005D,
	0xB0000000,	0x00000000,
		0x033, 0x00000076,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005A,
	0xB0000000,	0x00000000,
		0x033, 0x00000077,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FC,
	0xB0000000,	0x00000000,
		0x033, 0x00000078,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000079,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x0000007A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x0000007B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x0000007C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x0000007D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AC,
	0xB0000000,	0x00000000,
		0x033, 0x0000007E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AA,
	0xB0000000,	0x00000000,
		0x033, 0x0000007F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A7,
	0xB0000000,	0x00000000,
		0x033, 0x00000080,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A4,
	0xB0000000,	0x00000000,
		0x033, 0x00000081,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000006C,
	0xB0000000,	0x00000000,
		0x033, 0x00000082,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000069,
	0xB0000000,	0x00000000,
		0x033, 0x00000083,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000066,
	0xB0000000,	0x00000000,
		0x033, 0x00000084,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000063,
	0xB0000000,	0x00000000,
		0x033, 0x00000085,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000060,
	0xB0000000,	0x00000000,
		0x033, 0x00000086,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005D,
	0xB0000000,	0x00000000,
		0x033, 0x00000087,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005A,
	0xB0000000,	0x00000000,
		0x0EE, 0x00000000,
		0x0EE, 0x00004000,
		0x033, 0x00000000,
		0x03F, 0x00003BEF,
		0x033, 0x00000001,
		0x03F, 0x00003BE9,
		0x033, 0x00000002,
		0x03F, 0x00003BE3,
		0x033, 0x00000003,
		0x03F, 0x00003BDD,
		0x033, 0x00000004,
		0x03F, 0x00003BD7,
		0x033, 0x00000005,
		0x03F, 0x00003BD1,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0xA0000000,	0x00000000,
		0x03F, 0x00001BD9,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0xA0000000,	0x00000000,
		0x03F, 0x00001BD3,
	0xB0000000,	0x00000000,
		0x033, 0x00000008,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0xA0000000,	0x00000000,
		0x03F, 0x00000BD9,
	0xB0000000,	0x00000000,
		0x033, 0x00000009,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0xA0000000,	0x00000000,
		0x03F, 0x00000BD3,
	0xB0000000,	0x00000000,
		0x033, 0x0000000A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D9,
	0xB0000000,	0x00000000,
		0x033, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D3,
	0xB0000000,	0x00000000,
		0x033, 0x0000000C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000008D9,
	0xB0000000,	0x00000000,
		0x033, 0x0000000D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000008D3,
	0xB0000000,	0x00000000,
		0x033, 0x0000000E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000859,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0xA0000000,	0x00000000,
		0x03F, 0x00000859,
	0xB0000000,	0x00000000,
		0x033, 0x0000000F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000010,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000819,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0xA0000000,	0x00000000,
		0x03F, 0x00000819,
	0xB0000000,	0x00000000,
		0x033, 0x00000011,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x00000012,
		0x03F, 0x000039EE,
		0x033, 0x00000013,
		0x03F, 0x000039E8,
		0x033, 0x00000014,
		0x03F, 0x000039E2,
		0x033, 0x00000015,
		0x03F, 0x000039DC,
		0x033, 0x00000016,
		0x03F, 0x000039D6,
		0x033, 0x00000017,
		0x03F, 0x000039D0,
		0x033, 0x00000018,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D8,
	0xB0000000,	0x00000000,
		0x033, 0x00000019,
		0x03F, 0x000019D2,
		0x033, 0x0000001A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D8,
	0xB0000000,	0x00000000,
		0x033, 0x0000001B,
		0x03F, 0x000009D2,
		0x033, 0x0000001C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000008D9,
	0xB0000000,	0x00000000,
		0x033, 0x0000001D,
		0x03F, 0x000008D3,
		0x033, 0x0000001E,
		0x03F, 0x000008CD,
		0x033, 0x0000001F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000020,
		0x03F, 0x0000084D,
		0x033, 0x00000021,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x00000022,
		0x03F, 0x0000080D,
		0x033, 0x00000023,
		0x03F, 0x00000807,
		0x033, 0x00000024,
		0x03F, 0x000039EE,
		0x033, 0x00000025,
		0x03F, 0x000039E8,
		0x033, 0x00000026,
		0x03F, 0x000039E2,
		0x033, 0x00000027,
		0x03F, 0x000039DC,
		0x033, 0x00000028,
		0x03F, 0x000039D6,
		0x033, 0x00000029,
		0x03F, 0x000039D0,
		0x033, 0x0000002A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D8,
	0xB0000000,	0x00000000,
		0x033, 0x0000002B,
		0x03F, 0x000019D2,
		0x033, 0x0000002C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D8,
	0xB0000000,	0x00000000,
		0x033, 0x0000002D,
		0x03F, 0x000009D2,
		0x033, 0x0000002E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000008D9,
	0xB0000000,	0x00000000,
		0x033, 0x0000002F,
		0x03F, 0x000008D3,
		0x033, 0x00000030,
		0x03F, 0x000008CD,
		0x033, 0x00000031,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000032,
		0x03F, 0x0000084D,
		0x033, 0x00000033,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x00000034,
		0x03F, 0x0000080D,
		0x033, 0x00000035,
		0x03F, 0x00000807,
		0x033, 0x00000036,
		0x03F, 0x000039EE,
		0x033, 0x00000037,
		0x03F, 0x000039E8,
		0x033, 0x00000038,
		0x03F, 0x000039E2,
		0x033, 0x00000039,
		0x03F, 0x000039DC,
		0x033, 0x0000003A,
		0x03F, 0x000039D6,
		0x033, 0x0000003B,
		0x03F, 0x000039D0,
		0x033, 0x0000003C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D8,
	0xB0000000,	0x00000000,
		0x033, 0x0000003D,
		0x03F, 0x000019D2,
		0x033, 0x0000003E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D8,
	0xB0000000,	0x00000000,
		0x033, 0x0000003F,
		0x03F, 0x000009D2,
		0x033, 0x00000040,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000008D9,
	0xB0000000,	0x00000000,
		0x033, 0x00000041,
		0x03F, 0x000008D3,
		0x033, 0x00000042,
		0x03F, 0x000008CD,
		0x033, 0x00000043,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000044,
		0x03F, 0x0000084D,
		0x033, 0x00000045,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x00000046,
		0x03F, 0x0000080D,
		0x033, 0x00000047,
		0x03F, 0x00000807,
		0x033, 0x00000048,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0xA0000000,	0x00000000,
		0x03F, 0x000039EF,
	0xB0000000,	0x00000000,
		0x033, 0x00000049,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E9,
	0xB0000000,	0x00000000,
		0x033, 0x0000004A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E3,
	0xB0000000,	0x00000000,
		0x033, 0x0000004B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000039DD,
	0xB0000000,	0x00000000,
		0x033, 0x0000004C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D7,
	0xB0000000,	0x00000000,
		0x033, 0x0000004D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D1,
	0xB0000000,	0x00000000,
		0x033, 0x0000004E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0xA0000000,	0x00000000,
		0x03F, 0x000039CB,
	0xB0000000,	0x00000000,
		0x033, 0x0000004F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000050,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000019CD,
	0xB0000000,	0x00000000,
		0x033, 0x00000051,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000052,
		0x03F, 0x000009CD,
		0x033, 0x00000053,
		0x03F, 0x000008D3,
		0x033, 0x00000054,
		0x03F, 0x000008CD,
		0x033, 0x00000055,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000056,
		0x03F, 0x0000084D,
		0x033, 0x00000057,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x00000058,
		0x03F, 0x0000080D,
		0x033, 0x00000059,
		0x03F, 0x00000807,
		0x033, 0x0000005A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0xA0000000,	0x00000000,
		0x03F, 0x000039EF,
	0xB0000000,	0x00000000,
		0x033, 0x0000005B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E9,
	0xB0000000,	0x00000000,
		0x033, 0x0000005C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E3,
	0xB0000000,	0x00000000,
		0x033, 0x0000005D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000039DD,
	0xB0000000,	0x00000000,
		0x033, 0x0000005E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D7,
	0xB0000000,	0x00000000,
		0x033, 0x0000005F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D1,
	0xB0000000,	0x00000000,
		0x033, 0x00000060,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0xA0000000,	0x00000000,
		0x03F, 0x000039CB,
	0xB0000000,	0x00000000,
		0x033, 0x00000061,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000062,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000019CD,
	0xB0000000,	0x00000000,
		0x033, 0x00000063,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000064,
		0x03F, 0x000009CD,
		0x033, 0x00000065,
		0x03F, 0x000008D3,
		0x033, 0x00000066,
		0x03F, 0x000008CD,
		0x033, 0x00000067,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000068,
		0x03F, 0x0000084D,
		0x033, 0x00000069,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x0000006A,
		0x03F, 0x0000080D,
		0x033, 0x0000006B,
		0x03F, 0x00000807,
		0x033, 0x0000006C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0xA0000000,	0x00000000,
		0x03F, 0x000039EF,
	0xB0000000,	0x00000000,
		0x033, 0x0000006D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E9,
	0xB0000000,	0x00000000,
		0x033, 0x0000006E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E3,
	0xB0000000,	0x00000000,
		0x033, 0x0000006F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000039DD,
	0xB0000000,	0x00000000,
		0x033, 0x00000070,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D7,
	0xB0000000,	0x00000000,
		0x033, 0x00000071,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D1,
	0xB0000000,	0x00000000,
		0x033, 0x00000072,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0xA0000000,	0x00000000,
		0x03F, 0x000039CB,
	0xB0000000,	0x00000000,
		0x033, 0x00000073,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000074,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000019CD,
	0xB0000000,	0x00000000,
		0x033, 0x00000075,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000076,
		0x03F, 0x000009CD,
		0x033, 0x00000077,
		0x03F, 0x000008D3,
		0x033, 0x00000078,
		0x03F, 0x000008CD,
		0x033, 0x00000079,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x0000007A,
		0x03F, 0x0000084D,
		0x033, 0x0000007B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x0000007C,
		0x03F, 0x0000080D,
		0x033, 0x0000007D,
		0x03F, 0x00000807,
		0x033, 0x0000007E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0xA0000000,	0x00000000,
		0x03F, 0x000039EF,
	0xB0000000,	0x00000000,
		0x033, 0x0000007F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E9,
	0xB0000000,	0x00000000,
		0x033, 0x00000080,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E3,
	0xB0000000,	0x00000000,
		0x033, 0x00000081,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000039DD,
	0xB0000000,	0x00000000,
		0x033, 0x00000082,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D7,
	0xB0000000,	0x00000000,
		0x033, 0x00000083,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D1,
	0xB0000000,	0x00000000,
		0x033, 0x00000084,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0xA0000000,	0x00000000,
		0x03F, 0x000039CB,
	0xB0000000,	0x00000000,
		0x033, 0x00000085,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000086,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000019CD,
	0xB0000000,	0x00000000,
		0x033, 0x00000087,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000088,
		0x03F, 0x000009CD,
		0x033, 0x00000089,
		0x03F, 0x000008D3,
		0x033, 0x0000008A,
		0x03F, 0x000008CD,
		0x033, 0x0000008B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x0000008C,
		0x03F, 0x0000084D,
		0x033, 0x0000008D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x0000008E,
		0x03F, 0x0000080D,
		0x033, 0x0000008F,
		0x03F, 0x00000807,
		0x0EE, 0x00000000,
		0x0EF, 0x00080000,
		0x033, 0x00000007,
		0x03E, 0x00000001,
		0x03F, 0x00020F3C,
		0x0EF, 0x00000000,
		0x0EF, 0x00080000,
		0x033, 0x0000000C,
		0x03E, 0x00000001,
		0x03F, 0x000305BC,
		0x0EF, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000001,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0xA0000000,	0x00000000,
		0x0EC, 0x00000001,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
		0x03C, 0x00000020,
		0x03D, 0x00000078,
		0x03E, 0x00080000,
		0x03F, 0x00001999,
		0x0EC, 0x00000000,
		0x02F, 0x0002260D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000001,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0xA0000000,	0x00000000,
		0x0DE, 0x00000001,
	0xB0000000,	0x00000000,
		0x0EF, 0x00000002,
		0x033, 0x00000000,
		0x03F, 0x00000002,
		0x033, 0x00000001,
		0x03F, 0x00000002,
		0x0EF, 0x00000000,
		0x0EF, 0x00000400,
		0x033, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000001,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000002,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000004,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000005,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000008,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000009,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000010,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000011,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000012,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000013,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000014,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000015,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000016,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000017,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000018,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000019,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000020,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000021,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000022,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000023,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000024,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000025,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000026,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000027,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000028,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000029,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000002F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000030,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000031,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000032,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000033,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000034,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000035,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000036,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000037,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000038,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000039,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x0EF, 0x00000000,
		0x0EF, 0x00000200,
		0x033, 0x00000000,
		0x03F, 0x000001FF,
		0x033, 0x00000001,
		0x03F, 0x000001FF,
		0x033, 0x00000002,
		0x03F, 0x000001FF,
		0x033, 0x00000003,
		0x03F, 0x000001FF,
		0x033, 0x00000004,
		0x03F, 0x000001FF,
		0x033, 0x00000005,
		0x03F, 0x000001FF,
		0x033, 0x00000006,
		0x03F, 0x000001FF,
		0x033, 0x00000007,
		0x03F, 0x000001FF,
		0x033, 0x00000008,
		0x03F, 0x000001FF,
		0x033, 0x00000009,
		0x03F, 0x000001FF,
		0x033, 0x0000000A,
		0x03F, 0x000001FF,
		0x033, 0x0000000B,
		0x03F, 0x000001FF,
		0x033, 0x0000000C,
		0x03F, 0x000001FF,
		0x033, 0x0000000D,
		0x03F, 0x000001FF,
		0x033, 0x0000000E,
		0x03F, 0x000001FF,
		0x033, 0x0000000F,
		0x03F, 0x000001FF,
		0x033, 0x00000010,
		0x03F, 0x000001FF,
		0x033, 0x00000011,
		0x03F, 0x000001FF,
		0x033, 0x00000012,
		0x03F, 0x000001FF,
		0x033, 0x00000013,
		0x03F, 0x000001FF,
		0x033, 0x00000014,
		0x03F, 0x000001FF,
		0x033, 0x00000015,
		0x03F, 0x000001FF,
		0x033, 0x00000016,
		0x03F, 0x000001FF,
		0x033, 0x00000017,
		0x03F, 0x000001FF,
		0x033, 0x00000018,
		0x03F, 0x000001FF,
		0x033, 0x00000019,
		0x03F, 0x000001FF,
		0x033, 0x0000001A,
		0x03F, 0x000001FF,
		0x033, 0x0000001B,
		0x03F, 0x000001FF,
		0x033, 0x0000001C,
		0x03F, 0x000001FF,
		0x033, 0x0000001D,
		0x03F, 0x000001FF,
		0x033, 0x0000001E,
		0x03F, 0x000001FF,
		0x033, 0x0000001F,
		0x03F, 0x000001FF,
		0x033, 0x00000020,
		0x03F, 0x000001FF,
		0x033, 0x00000021,
		0x03F, 0x000001FF,
		0x033, 0x00000022,
		0x03F, 0x000001FF,
		0x033, 0x00000023,
		0x03F, 0x000001FF,
		0x033, 0x00000024,
		0x03F, 0x000001FF,
		0x033, 0x00000025,
		0x03F, 0x000001FF,
		0x033, 0x00000026,
		0x03F, 0x000001FF,
		0x033, 0x00000027,
		0x03F, 0x000001FF,
		0x033, 0x00000028,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000029,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000002F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000030,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000031,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000032,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000033,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000034,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000035,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000036,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000037,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000038,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000039,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x0EF, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0xA0000000,	0x00000000,
		0x06E, 0x00077A7C,
	0xB0000000,	0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0xA0000000,	0x00000000,
		0x06F, 0x00077A7C,
	0xB0000000,	0x00000000,
		0x06D, 0x00000C31,
		0x0EF, 0x00020000,
		0x033, 0x00000000,
		0x03F, 0x000005FF,
		0x0EF, 0x00000000,
		0x005, 0x00000001,
		0x0EF, 0x00080000,
		0x033, 0x00000001,
		0x03E, 0x00000001,
		0x03F, 0x00022020,
		0x0EF, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0xA0000000,	0x00000000,
		0x087, 0x00000427,
	0xB0000000,	0x00000000,
		0x002, 0x00000000,
		0x067, 0x00000053,

};


/******************************************************************************
 *                           radiob.TXT
 ******************************************************************************/

const u32 array_mp_8852a_radiob[] = {
		0xF0010000, 0x00000000,
		0xF0010001, 0x00000001,
		0xF0020001, 0x00000002,
		0xF0030001, 0x00000003,
		0xF0250001, 0x00000004,
		0xF0260001, 0x00000005,
		0xF0320001, 0x00000006,
		0xF0330001, 0x00000007,
		0xF0340001, 0x00000008,
		0xF0350001, 0x00000009,
		0xF0360001, 0x0000000A,
		0xF0010002, 0x0000000B,
		0xF0020002, 0x0000000C,
		0xF0030002, 0x0000000D,
		0xF0250002, 0x0000000E,
		0xF0260002, 0x0000000F,
		0xF0320002, 0x00000010,
		0xF0330002, 0x00000011,
		0xF0340002, 0x00000012,
		0xF0350002, 0x00000013,
		0xF0360002, 0x00000014,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000001,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x005, 0x00000000,
	0xA0000000,	0x00000000,
		0x005, 0x00000001,
	0xB0000000,	0x00000000,
		0x000, 0x00030000,
		0x018, 0x00011124,
		0x000, 0x00033C00,
		0x01A, 0x00040004,
		0x0FE, 0x00000000,
		0x055, 0x00080000,
		0x056, 0x0008FFF0,
		0x057, 0x0000C485,
		0x058, 0x000A4164,
		0x059, 0x00010000,
		0x05A, 0x00060000,
		0x05B, 0x0000A000,
		0x05C, 0x00000000,
		0x05D, 0x0001C013,
		0x05E, 0x00000000,
		0x05F, 0x00001FF0,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011000,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x060, 0x00011008,
	0xA0000000,	0x00000000,
		0x060, 0x00011000,
	0xB0000000,	0x00000000,
		0x061, 0x0009F338,
		0x062, 0x0009233A,
		0x063, 0x000D6002,
		0x064, 0x000A0CB0,
		0x065, 0x00030EFE,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00010000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x066, 0x00020000,
	0xA0000000,	0x00000000,
		0x066, 0x00010000,
	0xB0000000,	0x00000000,
		0x068, 0x00000000,
		0x069, 0x00030F0A,
		0x06A, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000AD6A4,
		0x052, 0x00091345,
		0x053, 0x00080081,
		0x054, 0x0007BC24,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x051, 0x000BD267,
		0x052, 0x00091345,
		0x053, 0x000B0081,
		0x054, 0x0007BCA4,
	0xA0000000,	0x00000000,
		0x051, 0x000AD6A4,
		0x052, 0x00091345,
		0x053, 0x00080081,
		0x054, 0x0007BC24,
	0xB0000000,	0x00000000,
		0x0D3, 0x00000143,
		0x043, 0x00005000,
		0x0DD, 0x000003A0,
		0x0B0, 0x000E6700,
		0x0AF, 0x0001F82E,
		0x0B2, 0x000210A7,
		0x0B1, 0x00065FFF,
		0x0BB, 0x000F7A00,
		0x0B3, 0x00013F7A,
		0x0D4, 0x0000000E,
		0x0B7, 0x00001E0C,
		0x0A0, 0x0000004F,
		0x0B4, 0x0007C03E,
		0x0B5, 0x0007E301,
		0x0B6, 0x00080800,
		0x0CA, 0x00002000,
		0x0DD, 0x000003A0,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x00080000,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x0CC, 0x000E0000,
	0xA0000000,	0x00000000,
		0x0CC, 0x00080000,
	0xB0000000,	0x00000000,
		0x0A1, 0x0006F300,
		0x0A2, 0x00080500,
		0x0A3, 0x0008050B,
		0x0A4, 0x0006DB12,
		0x0A5, 0x00000000,
		0x0A6, 0x00000000,
		0x0A7, 0x00000000,
		0x0A8, 0x00000000,
		0x0A9, 0x00000000,
		0x0AA, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x000B0000,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x0A5, 0x00000000,
	0xA0000000,	0x00000000,
		0x0A5, 0x000B0000,
	0xB0000000,	0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00008000,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x0ED, 0x00000000,
	0xA0000000,	0x00000000,
		0x0ED, 0x00008000,
	0xB0000000,	0x00000000,
		0x033, 0x00000000,
		0x03E, 0x00008000,
		0x03F, 0x000E1333,
		0x033, 0x00000001,
		0x03E, 0x00008000,
		0x03F, 0x000E7333,
		0x033, 0x00000002,
		0x03E, 0x00008000,
		0x03F, 0x000FA000,
		0x033, 0x00000003,
		0x03E, 0x00004000,
		0x03F, 0x000FA400,
		0x033, 0x00000004,
		0x03E, 0x00004000,
		0x03F, 0x000F5000,
		0x033, 0x00000005,
		0x03E, 0x00004001,
		0x03F, 0x00029400,
		0x033, 0x00000006,
		0x03E, 0x0000AAA1,
		0x03F, 0x00041999,
		0x033, 0x00000007,
		0x03E, 0x0000AAA1,
		0x03F, 0x00034444,
		0x033, 0x00000008,
		0x03E, 0x0000AAA1,
		0x03F, 0x0004D555,
		0x033, 0x00000009,
		0x03E, 0x00005551,
		0x03F, 0x00046AAA,
		0x033, 0x0000000A,
		0x03E, 0x00005551,
		0x03F, 0x00046AAA,
		0x033, 0x0000000B,
		0x03E, 0x00005551,
		0x03F, 0x0008C555,
		0x033, 0x0000000C,
		0x03E, 0x0000CCC1,
		0x03F, 0x00081EB8,
		0x033, 0x0000000D,
		0x03E, 0x0000CCC1,
		0x03F, 0x00071EB8,
		0x033, 0x0000000E,
		0x03E, 0x0000CCC1,
		0x03F, 0x00090000,
		0x033, 0x0000000F,
		0x03E, 0x00006661,
		0x03F, 0x00088000,
		0x033, 0x00000010,
		0x03E, 0x00006661,
		0x03F, 0x00088000,
		0x033, 0x00000011,
		0x03E, 0x00006661,
		0x03F, 0x000DB999,
		0x0ED, 0x00000000,
		0x0ED, 0x00002000,
		0x033, 0x00000002,
		0x03D, 0x0004A883,
		0x03E, 0x00000000,
		0x03F, 0x00000001,
		0x033, 0x00000006,
		0x03D, 0x0004A883,
		0x03E, 0x00000000,
		0x03F, 0x00000001,
		0x0ED, 0x00000000,
		0x018, 0x00001001,
		0x002, 0x0000000D,
		0x0EE, 0x00000004,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000A,
		0x033, 0x0000000C,
		0x03F, 0x00000011,
		0x033, 0x0000000D,
		0x03F, 0x00000018,
	0xA0000000,	0x00000000,
		0x033, 0x0000000B,
		0x03F, 0x0000000B,
		0x033, 0x0000000C,
		0x03F, 0x00000012,
		0x033, 0x0000000D,
		0x03F, 0x00000019,
	0xB0000000,	0x00000000,
		0x0EE, 0x00000000,
		0x08F, 0x000D0F7A,
		0x08C, 0x00084584,
		0x0EF, 0x00004000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0xA0000000,	0x00000000,
		0x03F, 0x00000700,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000700,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004700,
	0xA0000000,	0x00000000,
		0x03F, 0x00000700,
	0xB0000000,	0x00000000,
		0x033, 0x00000005,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000500,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000B0600,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00094600,
	0xA0000000,	0x00000000,
		0x03F, 0x00000500,
	0xB0000000,	0x00000000,
		0x033, 0x00000004,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000400,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4500,
	0xA0000000,	0x00000000,
		0x03F, 0x00000400,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00008B00,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00038B00,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000D4400,
	0xA0000000,	0x00000000,
		0x03F, 0x00008B00,
	0xB0000000,	0x00000000,
		0x033, 0x00000002,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000B00,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00014B00,
	0xA0000000,	0x00000000,
		0x03F, 0x00000B00,
	0xB0000000,	0x00000000,
		0x033, 0x00000001,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001A00,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004A00,
	0xA0000000,	0x00000000,
		0x03F, 0x00001A00,
	0xB0000000,	0x00000000,
		0x033, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00002900,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00004900,
	0xA0000000,	0x00000000,
		0x03F, 0x00002900,
	0xB0000000,	0x00000000,
		0x0EF, 0x00000000,
		0x0EF, 0x00001000,
		0x033, 0x00000000,
		0x03F, 0x00000015,
		0x033, 0x00000001,
		0x03F, 0x00000017,
		0x033, 0x00000002,
		0x03F, 0x00000015,
		0x033, 0x00000003,
		0x03F, 0x00000017,
		0x0EF, 0x00000000,
		0x0EF, 0x00008000,
		0x033, 0x00000000,
		0x03F, 0x000FECFC,
		0x033, 0x00000001,
		0x03F, 0x000BECFC,
		0x033, 0x00000002,
		0x03F, 0x0003E4FC,
		0x033, 0x00000003,
		0x03F, 0x0001D0FC,
		0x033, 0x00000004,
		0x03F, 0x0001C3FC,
		0x033, 0x00000005,
		0x03F, 0x000103FC,
		0x033, 0x00000006,
		0x03F, 0x0000007C,
		0x033, 0x00000007,
		0x03F, 0x0000007C,
		0x033, 0x00000008,
		0x03F, 0x000FECFC,
		0x033, 0x00000009,
		0x03F, 0x000BECFC,
		0x033, 0x0000000A,
		0x03F, 0x0003E4FC,
		0x033, 0x0000000B,
		0x03F, 0x0001D0FC,
		0x033, 0x0000000C,
		0x03F, 0x0001C3FC,
		0x033, 0x0000000D,
		0x03F, 0x000103FC,
		0x033, 0x0000000E,
		0x03F, 0x0000007C,
		0x033, 0x0000000F,
		0x03F, 0x0000007C,
		0x033, 0x00000010,
		0x03F, 0x000FECFC,
		0x033, 0x00000011,
		0x03F, 0x000BECFC,
		0x033, 0x00000012,
		0x03F, 0x0003E4FC,
		0x033, 0x00000013,
		0x03F, 0x0001D0FC,
		0x033, 0x00000014,
		0x03F, 0x0001C3FC,
		0x033, 0x00000015,
		0x03F, 0x000103FC,
		0x033, 0x00000016,
		0x03F, 0x0000007C,
		0x033, 0x00000017,
		0x03F, 0x0000007C,
		0x0EF, 0x00000000,
		0x0EF, 0x00000100,
		0x033, 0x00000000,
		0x03F, 0x00003317,
		0x033, 0x00000001,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000002,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000004,
		0x03F, 0x00003317,
		0x033, 0x00000005,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000008,
		0x03F, 0x00003317,
		0x033, 0x00000009,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x0000000A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0xA0000000,	0x00000000,
		0x03F, 0x00003336,
	0xB0000000,	0x00000000,
		0x033, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x0000000C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x0000000D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x0000000E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0xA0000000,	0x00000000,
		0x03F, 0x00003336,
	0xB0000000,	0x00000000,
		0x033, 0x0000000F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000010,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000011,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000012,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003336,
	0xA0000000,	0x00000000,
		0x03F, 0x00003336,
	0xB0000000,	0x00000000,
		0x033, 0x00000013,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003338,
	0xA0000000,	0x00000000,
		0x03F, 0x00003338,
	0xB0000000,	0x00000000,
		0x033, 0x00000014,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0xA0000000,	0x00000000,
		0x03F, 0x00003356,
	0xB0000000,	0x00000000,
		0x033, 0x00000015,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0xA0000000,	0x00000000,
		0x03F, 0x00003356,
	0xB0000000,	0x00000000,
		0x033, 0x00000016,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0xA0000000,	0x00000000,
		0x03F, 0x00003356,
	0xB0000000,	0x00000000,
		0x033, 0x00000017,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0xA0000000,	0x00000000,
		0x03F, 0x00003356,
	0xB0000000,	0x00000000,
		0x033, 0x00000018,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003337,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003356,
	0xA0000000,	0x00000000,
		0x03F, 0x00003356,
	0xB0000000,	0x00000000,
		0x033, 0x00000019,
		0x03F, 0x00003338,
		0x033, 0x0000001A,
		0x03F, 0x00003338,
		0x033, 0x0000001B,
		0x03F, 0x00003338,
		0x033, 0x0000001C,
		0x03F, 0x00003338,
		0x033, 0x0000001D,
		0x03F, 0x00003338,
		0x033, 0x0000001E,
		0x03F, 0x00003338,
		0x033, 0x0000001F,
		0x03F, 0x00003338,
		0x033, 0x00000020,
		0x03F, 0x00003338,
		0x033, 0x00000021,
		0x03F, 0x00003338,
		0x033, 0x00000022,
		0x03F, 0x00003338,
		0x033, 0x00000023,
		0x03F, 0x00003338,
		0x033, 0x00000024,
		0x03F, 0x00003338,
		0x033, 0x00000025,
		0x03F, 0x00003338,
		0x033, 0x00000026,
		0x03F, 0x00003338,
		0x033, 0x00000027,
		0x03F, 0x00003338,
		0x033, 0x00000028,
		0x03F, 0x00003338,
		0x033, 0x00000029,
		0x03F, 0x00003338,
		0x033, 0x0000002A,
		0x03F, 0x00003338,
		0x033, 0x0000002B,
		0x03F, 0x00003338,
		0x033, 0x0000002C,
		0x03F, 0x00003338,
		0x033, 0x0000002D,
		0x03F, 0x00003338,
		0x033, 0x0000002E,
		0x03F, 0x00003338,
		0x033, 0x0000002F,
		0x03F, 0x00003338,
		0x033, 0x00000030,
		0x03F, 0x00003338,
		0x0EF, 0x00000000,
		0x0EF, 0x00000040,
		0x033, 0x00000001,
		0x03F, 0x000004BA,
		0x033, 0x00000002,
		0x03F, 0x000004BA,
		0x033, 0x00000003,
		0x03F, 0x000004BA,
		0x033, 0x00000004,
		0x03F, 0x000004BA,
		0x033, 0x00000005,
		0x03F, 0x000004BA,
		0x033, 0x00000006,
		0x03F, 0x000004BA,
		0x033, 0x00000007,
		0x03F, 0x000004BA,
		0x033, 0x00000008,
		0x03F, 0x000004BA,
		0x033, 0x00000009,
		0x03F, 0x000004BA,
		0x033, 0x0000000A,
		0x03F, 0x000004BA,
		0x033, 0x0000000B,
		0x03F, 0x000004BA,
		0x0EF, 0x00000000,
		0x0EF, 0x00000010,
		0x033, 0x00000001,
		0x03F, 0x00000CB0,
		0x033, 0x00000002,
		0x03F, 0x00000CB0,
		0x033, 0x00000003,
		0x03F, 0x00000870,
		0x033, 0x00000004,
		0x03F, 0x00000870,
		0x033, 0x00000005,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0xA0000000,	0x00000000,
		0x03F, 0x00000430,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000730,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000430,
	0xA0000000,	0x00000000,
		0x03F, 0x00000430,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
		0x03F, 0x00000CB0,
		0x033, 0x00000008,
		0x03F, 0x00000CB0,
		0x033, 0x00000009,
		0x03F, 0x00000870,
		0x033, 0x0000000A,
		0x03F, 0x00000870,
		0x033, 0x0000000B,
		0x03F, 0x00000430,
		0x033, 0x0000000C,
		0x03F, 0x00000430,
		0x033, 0x0000000D,
		0x03F, 0x00000000,
		0x033, 0x0000000E,
		0x03F, 0x00000000,
		0x0EF, 0x00000000,
		0x0EF, 0x00000080,
		0x033, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0xB0000000,	0x00000000,
		0x033, 0x00000001,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0xB0000000,	0x00000000,
		0x033, 0x00000002,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002F258,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002F258,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0xB0000000,	0x00000000,
		0x033, 0x00000004,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0xB0000000,	0x00000000,
		0x033, 0x00000005,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0xB0000000,	0x00000000,
		0x033, 0x00000008,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C258,
	0xB0000000,	0x00000000,
		0x033, 0x00000009,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00036458,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0003C458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026458,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026458,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026458,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026458,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x0000000F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x00000010,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026458,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026458,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x00000011,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026458,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026658,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00026458,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x00000012,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x00000013,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x00000014,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x00000015,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x00000016,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00028558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x00000017,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xB0000000,	0x00000000,
		0x033, 0x00000018,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000019,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C358,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000001F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0002C558,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000020,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000021,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000022,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000023,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000024,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000025,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000026,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000027,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000028,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x00000029,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000002A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002F358,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002F358,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000002B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000002C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F258,
	0xB0000000,	0x00000000,
		0x033, 0x0000002D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x0000002E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x0000002F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x00000030,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x00000031,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x00000032,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x00000033,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x00000034,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x00000035,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x00000036,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x00000037,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x00000038,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x00000039,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023758,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00023558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x0000003A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00025558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x033, 0x0000003B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x00024558,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000C,
		0x03F, 0x0002C558,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xA0000000,	0x00000000,
		0x03E, 0x0000000B,
		0x03F, 0x0006F458,
	0xB0000000,	0x00000000,
		0x0EF, 0x00000000,
		0x0EE, 0x00002000,
		0x033, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000001,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000002,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x00000004,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x00000005,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0xA0000000,	0x00000000,
		0x03F, 0x000001EA,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000166,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AA,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000163,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A7,
	0xB0000000,	0x00000000,
		0x033, 0x00000008,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E8,
	0xB0000000,	0x00000000,
		0x033, 0x00000009,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E5,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E1,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E5,
	0xB0000000,	0x00000000,
		0x033, 0x0000000A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000068,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0xA0000000,	0x00000000,
		0x03F, 0x00000068,
	0xB0000000,	0x00000000,
		0x033, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000065,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x00000065,
	0xB0000000,	0x00000000,
		0x033, 0x0000000C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x00000062,
	0xB0000000,	0x00000000,
		0x033, 0x0000000D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005F,
	0xB0000000,	0x00000000,
		0x033, 0x0000000E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005C,
	0xB0000000,	0x00000000,
		0x033, 0x0000000F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x00000059,
	0xB0000000,	0x00000000,
		0x033, 0x00000010,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0xA0000000,	0x00000000,
		0x03F, 0x00000056,
	0xB0000000,	0x00000000,
		0x033, 0x00000011,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F5,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F5,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F5,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F5,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000012,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F2,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F2,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F2,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F2,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000013,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000014,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x00000015,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x00000016,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001EA,
	0xB0000000,	0x00000000,
		0x033, 0x00000017,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A5,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A5,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A5,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A5,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A9,
	0xB0000000,	0x00000000,
		0x033, 0x00000018,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A2,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A2,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A2,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A2,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A6,
	0xB0000000,	0x00000000,
		0x033, 0x00000019,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E5,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E5,
	0xB0000000,	0x00000000,
		0x033, 0x0000001A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E2,
	0xB0000000,	0x00000000,
		0x033, 0x0000001B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000DF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000065,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000065,
	0xB0000000,	0x00000000,
		0x033, 0x0000001D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000062,
	0xB0000000,	0x00000000,
		0x033, 0x0000001E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005F,
	0xB0000000,	0x00000000,
		0x033, 0x0000001F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005C,
	0xB0000000,	0x00000000,
		0x033, 0x00000020,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000059,
	0xB0000000,	0x00000000,
		0x033, 0x00000021,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000053,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000053,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000053,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000053,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000056,
	0xB0000000,	0x00000000,
		0x033, 0x00000022,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000023,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000024,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000025,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x00000026,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x00000027,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001EA,
	0xB0000000,	0x00000000,
		0x033, 0x00000028,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A9,
	0xB0000000,	0x00000000,
		0x033, 0x00000029,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A6,
	0xB0000000,	0x00000000,
		0x033, 0x0000002A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E5,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E5,
	0xB0000000,	0x00000000,
		0x033, 0x0000002B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E2,
	0xB0000000,	0x00000000,
		0x033, 0x0000002C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000DF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000065,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000065,
	0xB0000000,	0x00000000,
		0x033, 0x0000002E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000062,
	0xB0000000,	0x00000000,
		0x033, 0x0000002F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005F,
	0xB0000000,	0x00000000,
		0x033, 0x00000030,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005C,
	0xB0000000,	0x00000000,
		0x033, 0x00000031,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000059,
	0xB0000000,	0x00000000,
		0x033, 0x00000032,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000056,
	0xB0000000,	0x00000000,
		0x033, 0x00000033,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000070,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000034,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000035,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000036,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000067,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x00000037,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000064,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x00000038,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000061,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001EA,
	0xB0000000,	0x00000000,
		0x033, 0x00000039,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A9,
	0xB0000000,	0x00000000,
		0x033, 0x0000003A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A6,
	0xB0000000,	0x00000000,
		0x033, 0x0000003B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E5,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000058,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E5,
	0xB0000000,	0x00000000,
		0x033, 0x0000003C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E2,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000055,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000E2,
	0xB0000000,	0x00000000,
		0x033, 0x0000003D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000052,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000000DF,
	0xB0000000,	0x00000000,
		0x033, 0x0000003E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000065,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000065,
	0xB0000000,	0x00000000,
		0x033, 0x0000003F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000062,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000062,
	0xB0000000,	0x00000000,
		0x033, 0x00000040,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000049,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005F,
	0xB0000000,	0x00000000,
		0x033, 0x00000041,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000046,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005C,
	0xB0000000,	0x00000000,
		0x033, 0x00000042,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000059,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000043,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000059,
	0xB0000000,	0x00000000,
		0x033, 0x00000043,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000056,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000040,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000056,
	0xB0000000,	0x00000000,
		0x033, 0x00000044,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FC,
	0xB0000000,	0x00000000,
		0x033, 0x00000045,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000046,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000047,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000048,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x00000049,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x0000004A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AC,
	0xB0000000,	0x00000000,
		0x033, 0x0000004B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AA,
	0xB0000000,	0x00000000,
		0x033, 0x0000004C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A7,
	0xB0000000,	0x00000000,
		0x033, 0x0000004D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A4,
	0xB0000000,	0x00000000,
		0x033, 0x0000004E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000006C,
	0xB0000000,	0x00000000,
		0x033, 0x0000004F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000069,
	0xB0000000,	0x00000000,
		0x033, 0x00000050,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000066,
	0xB0000000,	0x00000000,
		0x033, 0x00000051,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000063,
	0xB0000000,	0x00000000,
		0x033, 0x00000052,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000060,
	0xB0000000,	0x00000000,
		0x033, 0x00000053,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005D,
	0xB0000000,	0x00000000,
		0x033, 0x00000054,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005A,
	0xB0000000,	0x00000000,
		0x033, 0x00000055,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FC,
	0xB0000000,	0x00000000,
		0x033, 0x00000056,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000057,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000058,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x00000059,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x0000005A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x0000005B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AC,
	0xB0000000,	0x00000000,
		0x033, 0x0000005C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AA,
	0xB0000000,	0x00000000,
		0x033, 0x0000005D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A7,
	0xB0000000,	0x00000000,
		0x033, 0x0000005E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A4,
	0xB0000000,	0x00000000,
		0x033, 0x0000005F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000006C,
	0xB0000000,	0x00000000,
		0x033, 0x00000060,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000069,
	0xB0000000,	0x00000000,
		0x033, 0x00000061,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000066,
	0xB0000000,	0x00000000,
		0x033, 0x00000062,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000063,
	0xB0000000,	0x00000000,
		0x033, 0x00000063,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000060,
	0xB0000000,	0x00000000,
		0x033, 0x00000064,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005D,
	0xB0000000,	0x00000000,
		0x033, 0x00000065,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005A,
	0xB0000000,	0x00000000,
		0x033, 0x00000066,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FC,
	0xB0000000,	0x00000000,
		0x033, 0x00000067,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000068,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x00000069,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x0000006A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x0000006B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x0000006C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AC,
	0xB0000000,	0x00000000,
		0x033, 0x0000006D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AA,
	0xB0000000,	0x00000000,
		0x033, 0x0000006E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A7,
	0xB0000000,	0x00000000,
		0x033, 0x0000006F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A4,
	0xB0000000,	0x00000000,
		0x033, 0x00000070,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000006C,
	0xB0000000,	0x00000000,
		0x033, 0x00000071,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000069,
	0xB0000000,	0x00000000,
		0x033, 0x00000072,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000066,
	0xB0000000,	0x00000000,
		0x033, 0x00000073,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000063,
	0xB0000000,	0x00000000,
		0x033, 0x00000074,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000060,
	0xB0000000,	0x00000000,
		0x033, 0x00000075,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005D,
	0xB0000000,	0x00000000,
		0x033, 0x00000076,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005A,
	0xB0000000,	0x00000000,
		0x033, 0x00000077,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000078,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FC,
	0xB0000000,	0x00000000,
		0x033, 0x00000078,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000075,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F9,
	0xB0000000,	0x00000000,
		0x033, 0x00000079,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F6,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000072,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F6,
	0xB0000000,	0x00000000,
		0x033, 0x0000007A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001EA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F3,
	0xB0000000,	0x00000000,
		0x033, 0x0000007B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001F0,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0xA0000000,	0x00000000,
		0x03F, 0x000001F0,
	0xB0000000,	0x00000000,
		0x033, 0x0000007C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001ED,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001E4,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0xA0000000,	0x00000000,
		0x03F, 0x000001ED,
	0xB0000000,	0x00000000,
		0x033, 0x0000007D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AC,
	0xB0000000,	0x00000000,
		0x033, 0x0000007E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001AA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0xA0000000,	0x00000000,
		0x03F, 0x000001AA,
	0xB0000000,	0x00000000,
		0x033, 0x0000007F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000E0,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A7,
	0xB0000000,	0x00000000,
		0x033, 0x00000080,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001A4,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x000001A4,
	0xB0000000,	0x00000000,
		0x033, 0x00000081,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000006C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000006C,
	0xB0000000,	0x00000000,
		0x033, 0x00000082,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000069,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000069,
	0xB0000000,	0x00000000,
		0x033, 0x00000083,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000066,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000066,
	0xB0000000,	0x00000000,
		0x033, 0x00000084,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000063,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000063,
	0xB0000000,	0x00000000,
		0x033, 0x00000085,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000060,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004E,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000057,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x00000060,
	0xB0000000,	0x00000000,
		0x033, 0x00000086,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000004B,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000054,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005D,
	0xB0000000,	0x00000000,
		0x033, 0x00000087,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000005A,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000048,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000051,
	0xA0000000,	0x00000000,
		0x03F, 0x0000005A,
	0xB0000000,	0x00000000,
		0x0EE, 0x00000000,
		0x0EE, 0x00004000,
		0x033, 0x00000000,
		0x03F, 0x00003BEF,
		0x033, 0x00000001,
		0x03F, 0x00003BE9,
		0x033, 0x00000002,
		0x03F, 0x00003BE3,
		0x033, 0x00000003,
		0x03F, 0x00003BDD,
		0x033, 0x00000004,
		0x03F, 0x00003BD7,
		0x033, 0x00000005,
		0x03F, 0x00003BD1,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00003BCB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD7,
	0xA0000000,	0x00000000,
		0x03F, 0x00001BD9,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BD1,
	0xA0000000,	0x00000000,
		0x03F, 0x00001BD3,
	0xB0000000,	0x00000000,
		0x033, 0x00000008,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00001BCD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD7,
	0xA0000000,	0x00000000,
		0x03F, 0x00000BD9,
	0xB0000000,	0x00000000,
		0x033, 0x00000009,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BD1,
	0xA0000000,	0x00000000,
		0x03F, 0x00000BD3,
	0xB0000000,	0x00000000,
		0x033, 0x0000000A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000BCD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D9,
	0xB0000000,	0x00000000,
		0x033, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D3,
	0xB0000000,	0x00000000,
		0x033, 0x0000000C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000008D9,
	0xB0000000,	0x00000000,
		0x033, 0x0000000D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000008D3,
	0xB0000000,	0x00000000,
		0x033, 0x0000000E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000859,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000857,
	0xA0000000,	0x00000000,
		0x03F, 0x00000859,
	0xB0000000,	0x00000000,
		0x033, 0x0000000F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000851,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000010,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000819,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000084D,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000817,
	0xA0000000,	0x00000000,
		0x03F, 0x00000819,
	0xB0000000,	0x00000000,
		0x033, 0x00000011,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000811,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x00000012,
		0x03F, 0x000039EE,
		0x033, 0x00000013,
		0x03F, 0x000039E8,
		0x033, 0x00000014,
		0x03F, 0x000039E2,
		0x033, 0x00000015,
		0x03F, 0x000039DC,
		0x033, 0x00000016,
		0x03F, 0x000039D6,
		0x033, 0x00000017,
		0x03F, 0x000039D0,
		0x033, 0x00000018,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D8,
	0xB0000000,	0x00000000,
		0x033, 0x00000019,
		0x03F, 0x000019D2,
		0x033, 0x0000001A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D8,
	0xB0000000,	0x00000000,
		0x033, 0x0000001B,
		0x03F, 0x000009D2,
		0x033, 0x0000001C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000008D9,
	0xB0000000,	0x00000000,
		0x033, 0x0000001D,
		0x03F, 0x000008D3,
		0x033, 0x0000001E,
		0x03F, 0x000008CD,
		0x033, 0x0000001F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000020,
		0x03F, 0x0000084D,
		0x033, 0x00000021,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x00000022,
		0x03F, 0x0000080D,
		0x033, 0x00000023,
		0x03F, 0x00000807,
		0x033, 0x00000024,
		0x03F, 0x000039EE,
		0x033, 0x00000025,
		0x03F, 0x000039E8,
		0x033, 0x00000026,
		0x03F, 0x000039E2,
		0x033, 0x00000027,
		0x03F, 0x000039DC,
		0x033, 0x00000028,
		0x03F, 0x000039D6,
		0x033, 0x00000029,
		0x03F, 0x000039D0,
		0x033, 0x0000002A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D8,
	0xB0000000,	0x00000000,
		0x033, 0x0000002B,
		0x03F, 0x000019D2,
		0x033, 0x0000002C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D8,
	0xB0000000,	0x00000000,
		0x033, 0x0000002D,
		0x03F, 0x000009D2,
		0x033, 0x0000002E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000008D9,
	0xB0000000,	0x00000000,
		0x033, 0x0000002F,
		0x03F, 0x000008D3,
		0x033, 0x00000030,
		0x03F, 0x000008CD,
		0x033, 0x00000031,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000032,
		0x03F, 0x0000084D,
		0x033, 0x00000033,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x00000034,
		0x03F, 0x0000080D,
		0x033, 0x00000035,
		0x03F, 0x00000807,
		0x033, 0x00000036,
		0x03F, 0x000039EE,
		0x033, 0x00000037,
		0x03F, 0x000039E8,
		0x033, 0x00000038,
		0x03F, 0x000039E2,
		0x033, 0x00000039,
		0x03F, 0x000039DC,
		0x033, 0x0000003A,
		0x03F, 0x000039D6,
		0x033, 0x0000003B,
		0x03F, 0x000039D0,
		0x033, 0x0000003C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D8,
	0xB0000000,	0x00000000,
		0x033, 0x0000003D,
		0x03F, 0x000019D2,
		0x033, 0x0000003E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D8,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D8,
	0xB0000000,	0x00000000,
		0x033, 0x0000003F,
		0x03F, 0x000009D2,
		0x033, 0x00000040,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008D9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CC,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000008D9,
	0xB0000000,	0x00000000,
		0x033, 0x00000041,
		0x03F, 0x000008D3,
		0x033, 0x00000042,
		0x03F, 0x000008CD,
		0x033, 0x00000043,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000044,
		0x03F, 0x0000084D,
		0x033, 0x00000045,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x00000046,
		0x03F, 0x0000080D,
		0x033, 0x00000047,
		0x03F, 0x00000807,
		0x033, 0x00000048,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0xA0000000,	0x00000000,
		0x03F, 0x000039EF,
	0xB0000000,	0x00000000,
		0x033, 0x00000049,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E9,
	0xB0000000,	0x00000000,
		0x033, 0x0000004A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E3,
	0xB0000000,	0x00000000,
		0x033, 0x0000004B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000039DD,
	0xB0000000,	0x00000000,
		0x033, 0x0000004C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D7,
	0xB0000000,	0x00000000,
		0x033, 0x0000004D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D1,
	0xB0000000,	0x00000000,
		0x033, 0x0000004E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0xA0000000,	0x00000000,
		0x03F, 0x000039CB,
	0xB0000000,	0x00000000,
		0x033, 0x0000004F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000050,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000019CD,
	0xB0000000,	0x00000000,
		0x033, 0x00000051,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000052,
		0x03F, 0x000009CD,
		0x033, 0x00000053,
		0x03F, 0x000008D3,
		0x033, 0x00000054,
		0x03F, 0x000008CD,
		0x033, 0x00000055,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000056,
		0x03F, 0x0000084D,
		0x033, 0x00000057,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x00000058,
		0x03F, 0x0000080D,
		0x033, 0x00000059,
		0x03F, 0x00000807,
		0x033, 0x0000005A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0xA0000000,	0x00000000,
		0x03F, 0x000039EF,
	0xB0000000,	0x00000000,
		0x033, 0x0000005B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E9,
	0xB0000000,	0x00000000,
		0x033, 0x0000005C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E3,
	0xB0000000,	0x00000000,
		0x033, 0x0000005D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000039DD,
	0xB0000000,	0x00000000,
		0x033, 0x0000005E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D7,
	0xB0000000,	0x00000000,
		0x033, 0x0000005F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D1,
	0xB0000000,	0x00000000,
		0x033, 0x00000060,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0xA0000000,	0x00000000,
		0x03F, 0x000039CB,
	0xB0000000,	0x00000000,
		0x033, 0x00000061,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000062,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000019CD,
	0xB0000000,	0x00000000,
		0x033, 0x00000063,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000064,
		0x03F, 0x000009CD,
		0x033, 0x00000065,
		0x03F, 0x000008D3,
		0x033, 0x00000066,
		0x03F, 0x000008CD,
		0x033, 0x00000067,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x00000068,
		0x03F, 0x0000084D,
		0x033, 0x00000069,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x0000006A,
		0x03F, 0x0000080D,
		0x033, 0x0000006B,
		0x03F, 0x00000807,
		0x033, 0x0000006C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0xA0000000,	0x00000000,
		0x03F, 0x000039EF,
	0xB0000000,	0x00000000,
		0x033, 0x0000006D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E9,
	0xB0000000,	0x00000000,
		0x033, 0x0000006E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E3,
	0xB0000000,	0x00000000,
		0x033, 0x0000006F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000039DD,
	0xB0000000,	0x00000000,
		0x033, 0x00000070,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D7,
	0xB0000000,	0x00000000,
		0x033, 0x00000071,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D1,
	0xB0000000,	0x00000000,
		0x033, 0x00000072,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0xA0000000,	0x00000000,
		0x03F, 0x000039CB,
	0xB0000000,	0x00000000,
		0x033, 0x00000073,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000074,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000019CD,
	0xB0000000,	0x00000000,
		0x033, 0x00000075,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000076,
		0x03F, 0x000009CD,
		0x033, 0x00000077,
		0x03F, 0x000008D3,
		0x033, 0x00000078,
		0x03F, 0x000008CD,
		0x033, 0x00000079,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x0000007A,
		0x03F, 0x0000084D,
		0x033, 0x0000007B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x0000007C,
		0x03F, 0x0000080D,
		0x033, 0x0000007D,
		0x03F, 0x00000807,
		0x033, 0x0000007E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EE,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039EF,
	0xA0000000,	0x00000000,
		0x03F, 0x000039EF,
	0xB0000000,	0x00000000,
		0x033, 0x0000007F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E8,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E9,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E9,
	0xB0000000,	0x00000000,
		0x033, 0x00000080,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039E3,
	0xA0000000,	0x00000000,
		0x03F, 0x000039E3,
	0xB0000000,	0x00000000,
		0x033, 0x00000081,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039DD,
	0xA0000000,	0x00000000,
		0x03F, 0x000039DD,
	0xB0000000,	0x00000000,
		0x033, 0x00000082,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D6,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D7,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D7,
	0xB0000000,	0x00000000,
		0x033, 0x00000083,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D0,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039D1,
	0xA0000000,	0x00000000,
		0x03F, 0x000039D1,
	0xB0000000,	0x00000000,
		0x033, 0x00000084,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CA,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000039CB,
	0xA0000000,	0x00000000,
		0x03F, 0x000039CB,
	0xB0000000,	0x00000000,
		0x033, 0x00000085,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000019D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000086,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CC,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000019CD,
	0xA0000000,	0x00000000,
		0x03F, 0x000019CD,
	0xB0000000,	0x00000000,
		0x033, 0x00000087,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D2,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000009D3,
	0xA0000000,	0x00000000,
		0x03F, 0x000009D3,
	0xB0000000,	0x00000000,
		0x033, 0x00000088,
		0x03F, 0x000009CD,
		0x033, 0x00000089,
		0x03F, 0x000008D3,
		0x033, 0x0000008A,
		0x03F, 0x000008CD,
		0x033, 0x0000008B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000008C7,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000853,
	0xA0000000,	0x00000000,
		0x03F, 0x00000853,
	0xB0000000,	0x00000000,
		0x033, 0x0000008C,
		0x03F, 0x0000084D,
		0x033, 0x0000008D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000847,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x00000813,
	0xA0000000,	0x00000000,
		0x03F, 0x00000813,
	0xB0000000,	0x00000000,
		0x033, 0x0000008E,
		0x03F, 0x0000080D,
		0x033, 0x0000008F,
		0x03F, 0x00000807,
		0x0EE, 0x00000000,
		0x0EF, 0x00080000,
		0x033, 0x00000007,
		0x03E, 0x00000001,
		0x03F, 0x00020F3C,
		0x0EF, 0x00000000,
		0x0EF, 0x00080000,
		0x033, 0x0000000C,
		0x03E, 0x00000001,
		0x03F, 0x000305BC,
		0x0EF, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000001,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x0EC, 0x00000000,
	0xA0000000,	0x00000000,
		0x0EC, 0x00000001,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
		0x03C, 0x00000020,
		0x03D, 0x00000078,
		0x03E, 0x00080000,
		0x03F, 0x00001999,
		0x0EC, 0x00000000,
		0x02F, 0x0002260D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000001,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x0DE, 0x00000000,
	0xA0000000,	0x00000000,
		0x0DE, 0x00000001,
	0xB0000000,	0x00000000,
		0x0EF, 0x00000002,
		0x033, 0x00000000,
		0x03F, 0x00000002,
		0x033, 0x00000001,
		0x03F, 0x00000002,
		0x0EF, 0x00000000,
		0x0EF, 0x00000400,
		0x033, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000001,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000002,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000003,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000004,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000005,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000006,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000007,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000008,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000009,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000000F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000010,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000011,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000012,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000013,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000014,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000015,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000016,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000017,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000018,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000019,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000001F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000020,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000021,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000001FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000022,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000023,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000024,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000025,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000026,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000027,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000017F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000017F,
	0xB0000000,	0x00000000,
		0x033, 0x00000028,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000029,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000013F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000002F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000030,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000031,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000032,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000033,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000034,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000035,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000036,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000037,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000038,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x00000039,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x033, 0x0000003F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FA,
	0xA0000000,	0x00000000,
		0x03F, 0x0000003F,
	0xB0000000,	0x00000000,
		0x0EF, 0x00000000,
		0x0EF, 0x00000200,
		0x033, 0x00000000,
		0x03F, 0x000001FF,
		0x033, 0x00000001,
		0x03F, 0x000001FF,
		0x033, 0x00000002,
		0x03F, 0x000001FF,
		0x033, 0x00000003,
		0x03F, 0x000001FF,
		0x033, 0x00000004,
		0x03F, 0x000001FF,
		0x033, 0x00000005,
		0x03F, 0x000001FF,
		0x033, 0x00000006,
		0x03F, 0x000001FF,
		0x033, 0x00000007,
		0x03F, 0x000001FF,
		0x033, 0x00000008,
		0x03F, 0x000001FF,
		0x033, 0x00000009,
		0x03F, 0x000001FF,
		0x033, 0x0000000A,
		0x03F, 0x000001FF,
		0x033, 0x0000000B,
		0x03F, 0x000001FF,
		0x033, 0x0000000C,
		0x03F, 0x000001FF,
		0x033, 0x0000000D,
		0x03F, 0x000001FF,
		0x033, 0x0000000E,
		0x03F, 0x000001FF,
		0x033, 0x0000000F,
		0x03F, 0x000001FF,
		0x033, 0x00000010,
		0x03F, 0x000001FF,
		0x033, 0x00000011,
		0x03F, 0x000001FF,
		0x033, 0x00000012,
		0x03F, 0x000001FF,
		0x033, 0x00000013,
		0x03F, 0x000001FF,
		0x033, 0x00000014,
		0x03F, 0x000001FF,
		0x033, 0x00000015,
		0x03F, 0x000001FF,
		0x033, 0x00000016,
		0x03F, 0x000001FF,
		0x033, 0x00000017,
		0x03F, 0x000001FF,
		0x033, 0x00000018,
		0x03F, 0x000001FF,
		0x033, 0x00000019,
		0x03F, 0x000001FF,
		0x033, 0x0000001A,
		0x03F, 0x000001FF,
		0x033, 0x0000001B,
		0x03F, 0x000001FF,
		0x033, 0x0000001C,
		0x03F, 0x000001FF,
		0x033, 0x0000001D,
		0x03F, 0x000001FF,
		0x033, 0x0000001E,
		0x03F, 0x000001FF,
		0x033, 0x0000001F,
		0x03F, 0x000001FF,
		0x033, 0x00000020,
		0x03F, 0x000001FF,
		0x033, 0x00000021,
		0x03F, 0x000001FF,
		0x033, 0x00000022,
		0x03F, 0x000001FF,
		0x033, 0x00000023,
		0x03F, 0x000001FF,
		0x033, 0x00000024,
		0x03F, 0x000001FF,
		0x033, 0x00000025,
		0x03F, 0x000001FF,
		0x033, 0x00000026,
		0x03F, 0x000001FF,
		0x033, 0x00000027,
		0x03F, 0x000001FF,
		0x033, 0x00000028,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x00000029,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000FF,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FB,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000001FF,
	0xA0000000,	0x00000000,
		0x03F, 0x000000FF,
	0xB0000000,	0x00000000,
		0x033, 0x0000002E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000002F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000030,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000031,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000032,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000033,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000034,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000035,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000036,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000037,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000038,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x00000039,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003A,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003B,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003C,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003D,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003E,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x033, 0x0000003F,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x000000EB,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003B,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x03F, 0x0000003F,
	0xA0000000,	0x00000000,
		0x03F, 0x000000EB,
	0xB0000000,	0x00000000,
		0x0EF, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00077A7C,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x06E, 0x00067A7C,
	0xA0000000,	0x00000000,
		0x06E, 0x00077A7C,
	0xB0000000,	0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00077A7C,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x06F, 0x00067A7C,
	0xA0000000,	0x00000000,
		0x06F, 0x00077A7C,
	0xB0000000,	0x00000000,
		0x06D, 0x00000C31,
		0x0EF, 0x00020000,
		0x033, 0x00000000,
		0x03F, 0x000005FF,
		0x0EF, 0x00000000,
		0x0A0, 0x00000043,
		0x005, 0x00000001,
		0x0EF, 0x00080000,
		0x033, 0x00000001,
		0x03E, 0x00000001,
		0x03F, 0x00022020,
		0x0EF, 0x00000000,
	0x80010000,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90010001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90020001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90030001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90250001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90260001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90320001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90330001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90340001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90350001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90360001,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90010002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90020002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90030002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90250002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90260002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x00000427,
	0x90320002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90330002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90340002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90350002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0x90360002,	0x00000000,	0x40000000,	0x00000000,
		0x087, 0x0000042F,
	0xA0000000,	0x00000000,
		0x087, 0x00000427,
	0xB0000000,	0x00000000,
		0x002, 0x00000000,
		0x067, 0x00000053,

};


/******************************************************************************
 *                           txpwr_lmt.TXT
 ******************************************************************************/

const struct halrf_tx_pw_lmt array_mp_8852a_txpwr_lmt[] = {
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 1, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 1, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 1, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 1, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 1, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 1, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 1, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 1, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 1, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 1, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 1, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 2, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 2, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 2, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 2, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 2, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 2, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 2, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 3, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 3, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 4, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 4, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 5, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 6, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 6, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 6, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 6, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 6, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 6, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 7, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 7, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 7, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 7, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 7, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 7, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 7, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 8, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 8, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 8, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 8, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 8, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 8, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 8, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 8, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 8, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 8, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 9, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 9, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 9, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 9, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 9, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 9, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 9, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 9, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 9, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 9, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 9, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 10, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 10, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 10, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 10, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 10, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 10, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 11, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 11, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 11, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 11, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 11, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 11, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 11, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 11, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 11, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 11, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 12, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 12, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 12, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 12, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 12, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 12, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 12, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 12, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 12, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 12, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 12, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 13, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 13, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 13, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 13, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 13, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 13, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 13, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 13, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 13, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 13, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 13, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 14, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 1, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 1, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 1, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 1, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 1, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 1, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 1, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 1, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 1, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 1, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 1, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 2, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 2, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 2, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 2, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 2, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 2, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 2, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 2, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 3, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 3, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 3, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 3, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 3, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 3, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 3, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 4, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 4, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 4, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 4, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 4, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 4, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 4, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 5, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 5, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 5, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 5, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 5, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 5, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 5, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 6, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 6, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 6, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 6, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 6, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 6, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 6, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 6, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 7, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 7, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 7, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 7, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 7, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 7, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 7, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 7, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 8, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 8, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 8, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 8, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 8, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 8, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 8, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 8, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 8, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 8, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 9, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 9, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 9, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 9, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 9, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 9, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 9, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 9, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 9, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 9, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 9, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 10, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 10, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 10, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 10, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 10, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 10, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 10, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 10, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 11, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 11, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 11, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 11, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 11, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 11, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 11, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 11, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 11, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 11, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 11, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 12, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 12, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 12, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 12, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 12, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 12, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 12, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 12, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 12, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 12, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 12, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 13, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 13, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 13, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 13, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 13, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 13, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 13, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 13, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 13, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 13, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 13, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 14, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 3, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 3, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 3, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 3, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 3, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 4, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 4, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 4, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 4, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 4, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 5, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 5, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 6, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 6, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 7, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 7, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 8, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 9, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 10, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 10, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 10, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 10, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 10, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 10, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 11, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 11, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 11, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 11, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 11, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 11, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 3, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 3, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 3, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 3, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 4, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 4, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 4, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 4, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 5, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 5, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 5, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 5, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 6, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 6, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 7, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 8, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 9, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 10, 24},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 10, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 10, 24},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 10, 24},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 10, 24},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 11, 24},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 11, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 11, 24},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 11, 24},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 11, 24},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_CCK, PW_LMT_NONBF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 1, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 1, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 1, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 1, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 1, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 1, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 1, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 1, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 1, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 1, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 1, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 2, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 2, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 2, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 2, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 2, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 2, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 2, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 2, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 2, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 3, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 4, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 4, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 4, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 4, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 7, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 8, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 8, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 8, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 8, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 8, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 8, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 9, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 9, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 9, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 10, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 10, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 10, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 11, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 11, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 11, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 11, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 11, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 12, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 12, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 12, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 12, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 12, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 12, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 13, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 13, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 13, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 13, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 13, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 13, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 13, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 13, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 13, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 13, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 13, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 1, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 1, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 1, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 1, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 1, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 1, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 1, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 1, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 1, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 1, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 1, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 2, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 2, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 2, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 2, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 2, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 2, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 2, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 2, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 2, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 2, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 2, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 3, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 3, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 3, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 3, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 3, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 4, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 4, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 5, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 5, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 5, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 6, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 6, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 6, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 7, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 7, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 7, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 8, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 8, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 8, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 8, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 8, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 8, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 9, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 9, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 9, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 9, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 10, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 10, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 10, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 10, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 10, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 10, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 11, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 11, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 11, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 11, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 11, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 11, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 12, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 12, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 12, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 12, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 12, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 12, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 12, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 13, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 13, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 13, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 13, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 13, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 13, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 13, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 1, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 1, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 1, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 1, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 1, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 1, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 1, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 1, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 1, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 1, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 1, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 2, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 2, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 2, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 2, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 2, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 2, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 2, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 2, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 2, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 3, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 4, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 4, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 4, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 4, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 7, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 8, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 8, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 8, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 8, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 8, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 8, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 9, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 9, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 9, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 10, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 10, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 10, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 11, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 11, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 11, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 11, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 11, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 12, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 12, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 12, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 12, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 12, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 12, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 13, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 13, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 13, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 13, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 13, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 13, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 13, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 13, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 13, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 13, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 13, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 1, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 1, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 1, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 1, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 1, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 1, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 1, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 1, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 1, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 1, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 1, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 2, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 2, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 2, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 2, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 2, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 2, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 2, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 2, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 2, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 2, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 2, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 3, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 3, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 3, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 3, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 3, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 4, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 4, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 5, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 5, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 5, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 6, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 6, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 6, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 7, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 7, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 7, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 8, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 8, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 8, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 9, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 10, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 10, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 10, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 11, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 11, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 11, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 12, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 12, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 12, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 12, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 12, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 12, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 12, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 13, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 13, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 13, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 13, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 13, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 13, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 13, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 1, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 1, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 1, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 1, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 1, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 1, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 1, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 1, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 1, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 1, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 1, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 2, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 2, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 2, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 2, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 2, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 2, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 2, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 2, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 2, 62},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 2, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 2, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 3, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 3, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 3, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 3, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 3, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 3, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 3, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 3, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 3, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 3, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 4, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 4, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 4, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 4, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 4, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 4, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 4, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 5, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 5, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 5, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 5, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 5, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 5, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 5, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 5, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 6, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 6, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 6, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 6, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 6, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 6, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 6, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 6, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 6, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 7, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 7, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 7, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 7, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 7, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 7, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 7, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 7, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 8, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 8, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 8, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 8, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 8, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 8, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 8, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 8, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 9, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 9, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 9, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 9, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 9, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 9, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 10, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 10, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 10, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 10, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 10, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 10, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 10, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 10, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 11, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 11, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 11, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 11, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 11, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 11, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 11, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 11, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 12, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 12, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 12, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 12, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 12, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 12, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 12, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 12, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 13, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 13, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 13, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 13, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 13, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 13, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 13, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 13, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 3, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 3, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 4, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 4, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 5, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 5, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 6, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 6, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 6, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 6, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 6, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 7, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 7, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 7, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 7, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 7, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 7, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 8, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 8, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 8, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 8, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 9, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 9, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 9, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 9, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 9, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 9, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 10, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 10, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 10, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 10, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 10, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 10, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 11, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 11, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 11, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 11, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 11, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 11, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 3, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 3, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 3, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 4, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 4, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 4, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 5, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 5, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 5, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 6, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 6, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 6, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 7, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 7, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 7, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 7, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 7, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 7, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 8, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 8, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 8, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 8, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 8, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 9, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 9, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 9, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 9, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 9, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 10, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 10, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 10, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 10, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 10, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 10, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 11, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 11, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 11, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 11, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 11, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 11, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 1, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 2, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 3, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 3, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 3, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 3, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 3, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 3, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 3, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 3, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 4, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 4, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 4, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 4, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 4, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 4, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 4, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 4, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 5, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 5, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 5, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 5, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 5, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 5, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 5, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 5, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 6, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 6, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 6, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 6, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 6, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 6, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 6, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 6, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 7, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 7, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 7, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 7, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 7, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 7, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 7, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 7, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 7, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 7, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 7, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 8, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 8, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 8, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 8, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 8, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 8, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 8, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 8, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 8, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 8, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 8, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 9, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 9, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 9, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 9, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 9, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 9, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 9, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 9, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 9, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 9, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 10, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 10, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 10, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 10, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 10, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 10, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 10, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 10, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 10, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 10, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 10, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 11, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 11, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 11, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 11, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 11, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 11, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 11, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 11, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 11, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 11, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 11, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 12, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 13, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 36, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 36, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 36, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 36, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 36, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 36, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 36, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 36, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 36, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 36, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 36, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 40, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 40, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 40, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 40, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 40, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 40, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 40, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 40, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 40, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 40, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 40, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 44, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 44, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 44, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 44, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 44, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 44, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 44, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 44, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 44, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 44, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 44, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 48, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 48, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 48, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 48, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 48, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 48, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 48, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 48, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 48, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 48, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 48, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 52, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 52, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 52, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 52, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 52, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 52, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 52, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 52, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 52, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 52, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 52, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 56, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 56, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 56, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 56, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 56, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 56, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 56, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 56, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 56, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 56, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 56, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 60, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 60, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 60, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 60, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 60, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 60, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 60, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 60, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 60, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 60, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 60, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 64, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 64, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 64, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 64, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 64, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 64, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 64, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 64, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 64, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 64, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 64, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 100, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 100, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 100, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 100, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 100, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 100, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 100, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 100, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 100, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 100, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 100, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 104, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 104, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 104, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 104, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 104, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 104, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 104, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 104, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 104, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 104, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 104, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 108, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 108, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 108, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 108, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 108, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 108, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 108, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 108, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 108, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 108, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 108, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 112, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 112, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 112, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 112, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 112, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 112, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 112, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 112, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 112, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 112, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 112, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 116, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 116, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 116, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 116, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 116, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 116, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 116, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 116, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 116, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 116, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 116, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 120, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 120, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 120, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 120, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 120, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 120, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 120, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 120, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 124, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 124, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 124, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 124, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 124, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 124, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 124, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 124, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 128, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 128, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 128, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 128, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 128, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 128, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 128, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 128, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 132, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 132, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 132, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 132, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 132, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 132, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 132, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 132, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 132, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 132, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 132, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 136, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 136, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 136, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 136, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 136, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 136, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 136, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 136, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 136, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 136, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 136, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 140, 74},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 140, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 140, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 140, 74},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 140, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 140, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 140, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 140, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 140, 74},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 140, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 140, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 144, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 149, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 149, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 149, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 153, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 153, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 157, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 157, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 161, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 161, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 165, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 165, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 36, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 36, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 36, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 36, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 36, 18},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 36, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 36, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 40, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 40, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 40, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 40, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 40, 18},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 40, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 40, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 44, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 44, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 44, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 44, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 44, 18},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 44, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 44, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 48, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 48, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 48, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 48, 44},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 48, 18},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 48, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 48, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 52, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 52, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 52, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 52, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 52, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 52, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 52, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 56, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 56, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 56, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 56, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 56, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 56, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 56, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 60, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 60, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 60, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 60, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 60, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 60, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 60, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 64, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 64, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 64, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 64, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 64, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 64, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 64, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 100, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 100, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 100, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 100, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 100, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 100, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 100, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 100, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 100, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 104, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 104, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 104, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 104, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 104, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 104, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 104, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 104, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 104, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 108, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 108, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 108, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 108, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 108, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 108, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 108, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 108, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 108, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 112, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 112, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 112, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 112, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 112, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 112, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 112, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 112, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 112, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 116, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 116, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 116, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 116, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 116, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 116, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 116, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 116, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 116, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 120, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 120, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 120, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 120, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 120, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 120, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 120, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 120, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 124, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 124, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 124, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 124, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 124, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 124, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 124, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 124, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 128, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 128, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 128, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 128, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 128, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 128, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 128, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 128, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 132, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 132, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 132, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 132, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 132, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 132, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 132, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 132, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 132, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 136, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 136, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 136, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 136, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 136, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 136, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 136, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 136, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 136, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 140, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 140, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 140, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 140, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 140, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 140, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 140, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 140, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 140, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 144, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 144, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 144, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 144, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 144, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 144, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 144, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 149, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 149, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 149, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 149, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 153, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 153, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 153, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 157, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 157, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 157, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 161, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 161, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 161, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_FCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MKK, 165, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_IC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_KCC, 165, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 165, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_CN, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_OFDM, PW_LMT_NONBF, PW_LMT_REGU_NULL, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 36, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 36, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 36, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 36, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 36, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 36, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 36, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 36, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 36, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 36, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 36, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 40, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 40, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 40, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 40, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 40, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 40, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 40, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 40, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 40, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 40, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 40, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 44, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 44, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 44, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 44, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 44, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 44, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 44, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 44, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 44, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 44, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 44, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 48, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 48, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 48, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 48, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 48, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 48, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 48, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 48, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 48, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 48, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 48, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 52, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 52, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 52, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 52, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 52, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 52, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 52, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 52, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 52, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 52, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 52, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 56, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 56, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 56, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 56, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 56, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 56, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 56, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 56, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 56, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 56, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 56, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 60, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 60, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 60, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 60, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 60, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 60, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 60, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 60, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 60, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 60, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 60, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 64, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 64, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 64, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 64, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 64, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 64, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 64, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 64, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 64, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 64, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 64, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 100, 74},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 100, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 100, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 100, 74},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 100, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 100, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 100, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 100, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 100, 74},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 100, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 100, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 104, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 104, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 104, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 104, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 104, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 104, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 104, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 104, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 104, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 104, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 104, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 108, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 108, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 108, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 108, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 108, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 108, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 108, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 108, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 108, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 108, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 108, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 112, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 112, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 112, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 112, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 112, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 112, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 112, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 112, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 112, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 112, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 112, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 116, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 116, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 116, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 116, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 116, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 116, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 116, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 116, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 116, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 116, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 116, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 120, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 120, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 120, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 120, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 120, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 120, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 120, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 120, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 124, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 124, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 124, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 124, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 124, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 124, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 124, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 124, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 128, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 128, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 128, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 128, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 128, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 128, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 128, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 128, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 132, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 132, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 132, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 132, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 132, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 132, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 132, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 132, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 132, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 132, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 132, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 136, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 136, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 136, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 136, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 136, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 136, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 136, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 136, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 136, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 136, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 136, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 140, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 140, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 140, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 140, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 140, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 140, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 140, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 140, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 140, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 140, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 140, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 144, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 144, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 149, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 149, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 149, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 153, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 153, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 157, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 157, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 161, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 161, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 165, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 165, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 36, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 36, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 36, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 36, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 36, 18},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 36, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 36, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 40, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 40, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 40, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 40, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 40, 18},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 40, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 40, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 44, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 44, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 44, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 44, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 44, 18},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 44, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 44, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 48, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 48, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 48, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 48, 38},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 48, 18},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 48, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 48, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 52, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 52, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 52, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 52, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 52, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 52, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 52, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 56, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 56, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 56, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 56, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 56, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 56, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 56, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 60, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 60, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 60, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 60, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 60, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 60, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 60, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 64, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 64, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 64, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 64, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 64, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 64, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 64, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 100, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 100, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 100, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 100, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 100, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 100, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 100, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 100, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 100, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 104, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 104, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 104, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 104, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 104, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 104, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 104, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 104, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 104, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 108, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 108, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 108, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 108, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 108, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 108, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 108, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 108, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 108, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 112, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 112, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 112, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 112, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 112, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 112, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 112, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 112, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 112, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 116, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 116, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 116, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 116, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 116, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 116, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 116, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 116, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 116, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 120, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 120, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 120, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 120, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 120, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 120, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 120, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 120, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 124, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 124, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 124, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 124, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 124, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 124, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 124, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 124, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 128, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 128, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 128, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 128, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 128, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 128, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 128, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 128, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 132, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 132, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 132, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 132, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 132, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 132, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 132, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 132, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 132, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 136, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 136, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 136, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 136, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 136, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 136, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 136, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 136, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 136, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 140, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 140, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 140, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 140, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 140, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 140, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 140, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 140, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 140, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 144, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 144, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 144, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 144, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 144, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 144, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 144, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 149, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 149, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 149, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 149, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 153, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 153, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 153, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 157, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 157, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 157, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 161, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 161, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 161, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 165, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 165, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 165, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 36, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 36, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 36, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 36, 38},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 36, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 36, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 36, 6},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 36, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 36, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 36, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 36, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 40, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 40, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 40, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 40, 38},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 40, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 40, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 40, 6},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 40, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 40, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 40, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 40, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 44, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 44, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 44, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 44, 38},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 44, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 44, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 44, 6},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 44, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 44, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 44, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 44, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 48, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 48, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 48, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 48, 38},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 48, 38},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 48, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 48, 6},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 48, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 48, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 48, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 48, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 52, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 52, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 52, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 52, 38},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 52, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 52, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 52, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 52, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 52, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 52, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 52, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 56, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 56, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 56, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 56, 38},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 56, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 56, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 56, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 56, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 56, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 56, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 56, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 60, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 60, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 60, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 60, 38},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 60, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 60, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 60, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 60, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 60, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 60, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 60, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 64, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 64, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 64, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 64, 38},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 64, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 64, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 64, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 64, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 64, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 64, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 64, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 100, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 100, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 100, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 100, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 100, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 100, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 100, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 100, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 100, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 100, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 100, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 104, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 104, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 104, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 104, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 104, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 104, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 104, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 104, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 104, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 104, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 104, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 108, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 108, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 108, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 108, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 108, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 108, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 108, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 108, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 108, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 108, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 108, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 112, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 112, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 112, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 112, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 112, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 112, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 112, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 112, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 112, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 112, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 112, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 116, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 116, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 116, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 116, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 116, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 116, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 116, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 116, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 116, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 116, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 116, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 120, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 120, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 120, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 120, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 120, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 120, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 120, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 120, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 124, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 124, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 124, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 124, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 124, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 124, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 124, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 124, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 128, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 128, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 128, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 128, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 128, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 128, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 128, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 128, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 132, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 132, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 132, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 132, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 132, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 132, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 132, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 132, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 132, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 132, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 132, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 136, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 136, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 136, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 136, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 136, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 136, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 136, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 136, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 136, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 136, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 136, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 140, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 140, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 140, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 140, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 140, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 140, 34},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 140, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 140, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 140, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 140, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 140, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 144, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 144, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 144, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 144, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 144, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 144, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 144, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 149, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 149, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 149, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 149, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 149, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 149, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 149, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 153, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 153, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 153, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 153, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 153, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 153, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 153, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 157, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 157, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 157, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 157, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 157, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 157, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 157, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 161, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 161, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 161, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 161, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 161, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 161, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 161, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 165, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 165, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 165, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 165, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 165, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 165, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_20M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 165, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 38, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 38, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 38, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 38, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 38, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 38, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 38, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 38, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 38, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 38, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 38, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 46, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 46, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 46, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 46, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 46, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 46, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 46, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 46, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 46, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 46, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 46, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 54, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 54, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 54, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 54, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 54, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 54, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 54, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 54, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 54, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 54, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 54, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 62, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 62, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 62, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 62, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 62, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 62, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 62, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 62, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 62, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 62, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 62, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 102, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 102, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 102, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 102, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 102, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 102, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 102, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 102, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 102, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 102, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 102, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 110, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 110, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 110, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 110, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 110, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 110, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 110, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 110, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 110, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 110, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 110, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 118, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 118, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 118, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 118, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 118, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 118, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 118, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 118, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 118, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 118, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 118, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 126, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 126, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 126, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 126, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 126, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 126, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 126, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 126, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 126, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 126, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 126, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 134, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 134, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 134, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 134, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 134, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 134, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 134, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 134, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 134, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 134, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 134, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 142, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 151, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 151, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 151, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 151, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 151, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 151, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 159, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 159, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 159, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 159, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 159, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 38, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 38, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 38, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 38, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 38, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 38, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 38, 18},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 38, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 38, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 38, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 38, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 46, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 46, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 46, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 46, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 46, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 46, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 46, 18},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 46, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 46, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 46, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 46, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 54, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 54, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 54, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 54, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 54, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 54, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 54, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 54, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 54, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 54, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 54, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 62, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 62, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 62, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 62, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 62, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 62, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 62, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 62, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 62, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 62, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 62, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 102, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 102, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 102, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 102, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 102, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 102, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 102, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 102, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 102, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 102, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 102, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 110, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 110, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 110, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 110, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 110, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 110, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 110, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 110, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 110, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 110, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 110, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 118, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 118, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 118, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 118, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 118, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 118, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 118, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 118, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 118, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 118, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 118, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 126, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 126, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 126, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 126, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 126, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 126, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 126, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 126, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 126, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 126, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 126, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 134, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 134, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 134, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 134, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 134, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 134, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 134, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 134, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 134, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 134, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 134, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 142, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 142, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 151, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 151, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 151, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 151, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 151, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 151, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 151, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 159, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 159, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 159, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 159, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 159, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 159, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 38, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 38, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 38, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 38, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 38, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 38, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 38, 6},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 38, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 38, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 38, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 38, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 46, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 46, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 46, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 46, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 46, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 46, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 46, 6},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 46, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 46, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 46, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 46, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 54, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 54, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 54, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 54, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 54, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 54, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 54, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 54, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 54, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 54, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 54, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 62, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 62, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 62, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 62, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 62, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 62, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 62, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 62, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 62, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 62, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 62, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 102, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 102, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 102, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 102, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 102, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 102, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 102, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 102, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 102, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 102, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 102, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 110, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 110, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 110, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 110, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 110, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 110, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 110, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 110, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 110, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 110, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 110, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 118, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 118, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 118, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 118, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 118, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 118, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 118, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 118, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 118, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 118, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 118, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 126, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 126, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 126, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 126, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 126, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 126, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 126, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 126, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 126, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 126, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 126, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 134, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 134, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 134, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 134, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 134, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 134, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 134, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 134, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 134, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 134, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 134, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 142, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 142, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 142, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 142, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 142, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 142, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 142, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 142, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 151, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 151, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 151, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 151, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 151, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 151, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 151, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 151, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 159, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 159, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 159, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 159, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 159, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 159, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_40M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 159, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 42, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 42, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 42, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 42, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 42, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 42, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 42, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 42, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 42, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 42, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 42, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 58, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 58, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 58, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 58, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 58, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 58, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 58, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 58, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 58, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 58, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 58, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 106, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 106, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 106, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 106, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 106, 70},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 106, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 106, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 106, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 106, 62},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 106, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 106, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 122, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 122, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 122, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 122, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 122, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 122, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 122, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 122, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 122, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 122, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 122, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 138, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 155, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 155, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 155, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 155, 54},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 155, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 155, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 155, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 42, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 42, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 42, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 42, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 42, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 42, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 42, 18},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 42, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 42, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 42, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 42, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 58, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 58, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 58, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 58, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 58, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 58, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 58, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 58, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 58, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 58, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 58, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 106, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 106, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 106, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 106, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 106, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 106, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 106, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 106, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 106, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 106, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 106, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 122, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 122, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 122, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 122, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 122, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 122, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 122, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 122, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 122, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 122, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 122, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 138, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 138, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_FCC, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ETSI, 155, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MKK, 155, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_IC, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_KCC, 155, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_ACMA, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CHILE, 155, 42},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_UKRAINE, 155, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_MEXICO, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_CN, 155, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_NONBF, PW_LMT_REGU_NULL, 155, 16},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 42, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 42, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 42, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 42, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 42, 66},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 42, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 42, 6},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 42, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 42, 50},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 42, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 42, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 58, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 58, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 58, 52},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 58, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 58, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 58, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 58, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 58, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 58, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 58, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 58, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 106, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 106, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 106, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 106, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 106, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 106, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 106, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 106, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 106, 56},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 106, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 106, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 122, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 122, 40},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 122, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 122, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 122, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 122, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 122, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 122, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 122, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 122, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 122, 28},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 138, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 138, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 138, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 138, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 138, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 138, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 138, 68},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 138, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_FCC, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ETSI, 155, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MKK, 155, 127},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_IC, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_KCC, 155, 58},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_ACMA, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CHILE, 155, 30},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_UKRAINE, 155, 4},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_MEXICO, 155, 72},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_CN, 155, 64},
	{PW_LMT_BAND_5G, PW_LMT_BW_80M, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_BF, PW_LMT_REGU_NULL, 155, 4}
};


/******************************************************************************
 *                           txpwr_lmt_ru.TXT
 ******************************************************************************/

const struct halrf_tx_pw_lmt_ru array_mp_8852a_txpwr_lmt_ru[] = {
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 1, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 1, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 1, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 1, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 1, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 1, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 1, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 1, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 1, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 1, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 1, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 2, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 2, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 2, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 2, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 2, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 2, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 2, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 2, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 2, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 2, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 2, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 3, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 3, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 3, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 3, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 3, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 3, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 3, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 3, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 3, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 3, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 3, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 4, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 4, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 4, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 4, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 4, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 4, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 4, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 4, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 4, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 4, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 4, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 5, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 5, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 5, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 5, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 5, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 5, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 5, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 6, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 6, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 6, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 6, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 6, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 6, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 6, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 7, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 7, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 7, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 7, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 7, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 7, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 7, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 7, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 8, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 8, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 8, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 8, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 8, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 8, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 8, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 8, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 9, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 9, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 9, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 9, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 9, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 9, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 9, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 9, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 9, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 9, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 9, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 10, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 10, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 10, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 10, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 10, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 10, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 10, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 10, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 10, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 10, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 11, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 11, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 11, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 11, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 11, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 11, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 11, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 11, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 11, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 11, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 12, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 12, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 12, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 12, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 12, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 12, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 12, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 13, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 13, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 13, 46},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 13, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 13, 34},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 1, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 1, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 1, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 1, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 1, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 1, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 1, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 1, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 1, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 1, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 1, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 2, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 2, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 2, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 2, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 2, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 2, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 2, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 2, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 2, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 2, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 2, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 3, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 3, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 3, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 3, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 3, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 3, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 3, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 3, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 3, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 3, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 3, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 4, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 4, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 4, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 4, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 4, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 4, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 4, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 4, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 4, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 4, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 4, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 5, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 5, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 5, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 5, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 5, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 5, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 5, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 5, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 5, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 6, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 6, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 6, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 6, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 6, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 6, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 6, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 6, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 7, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 7, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 7, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 7, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 7, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 7, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 7, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 7, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 7, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 8, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 8, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 8, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 8, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 8, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 8, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 8, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 8, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 8, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 8, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 8, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 9, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 9, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 9, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 9, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 9, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 9, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 9, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 9, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 9, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 9, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 9, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 10, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 10, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 10, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 10, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 10, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 10, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 10, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 10, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 10, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 10, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 10, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 11, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 11, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 11, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 11, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 11, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 11, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 11, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 11, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 11, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 11, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 11, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 12, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 12, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 12, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 12, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 12, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 12, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 12, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 12, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 12, 54},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 12, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 12, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 13, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 13, 28},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 13, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 13, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 13, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 13, 20},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 1, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 1, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 1, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 1, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 1, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 1, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 1, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 1, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 1, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 1, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 1, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 2, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 2, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 2, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 2, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 2, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 2, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 2, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 2, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 2, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 2, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 2, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 3, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 3, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 3, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 3, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 3, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 3, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 3, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 3, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 3, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 4, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 4, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 4, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 4, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 4, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 4, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 4, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 4, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 4, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 4, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 4, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 5, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 5, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 5, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 5, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 5, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 5, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 5, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 6, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 6, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 6, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 6, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 6, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 6, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 6, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 7, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 7, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 7, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 7, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 7, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 7, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 7, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 7, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 8, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 8, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 8, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 8, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 8, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 8, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 8, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 8, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 9, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 9, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 9, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 9, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 9, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 9, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 9, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 9, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 9, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 9, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 9, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 10, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 10, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 10, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 10, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 10, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 10, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 10, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 10, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 10, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 10, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 11, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 11, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 11, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 11, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 11, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 11, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 11, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 11, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 11, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 11, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 12, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 12, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 12, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 12, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 12, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 12, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 12, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 13, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 13, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 13, 50},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 13, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 13, 58},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 13, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 13, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 13, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 13, 36},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 13, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 13, 42},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 1, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 1, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 1, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 1, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 1, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 1, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 1, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 1, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 1, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 1, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 1, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 2, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 2, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 2, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 2, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 2, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 2, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 2, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 2, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 2, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 2, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 2, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 3, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 3, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 3, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 3, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 3, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 3, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 3, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 3, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 4, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 4, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 4, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 4, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 4, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 4, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 4, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 4, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 4, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 4, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 4, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 5, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 5, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 5, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 5, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 5, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 5, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 5, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 5, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 6, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 6, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 6, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 6, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 6, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 6, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 6, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 6, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 7, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 7, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 7, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 7, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 7, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 7, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 7, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 7, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 8, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 8, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 8, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 8, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 8, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 8, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 8, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 8, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 8, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 8, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 8, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 9, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 9, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 9, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 9, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 9, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 9, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 9, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 9, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 10, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 10, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 10, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 10, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 10, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 10, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 10, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 10, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 10, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 10, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 10, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 11, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 11, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 11, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 11, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 11, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 11, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 11, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 11, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 11, 66},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 11, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 11, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 12, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 12, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 12, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 12, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 12, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 12, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 12, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 12, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 12, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 12, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 12, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 13, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 13, 38},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 13, 44},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 13, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 13, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 13, 32},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 13, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 13, 30},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 1, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 1, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 1, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 1, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 1, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 1, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 1, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 1, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 1, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 1, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 1, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 2, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 2, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 2, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 2, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 2, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 2, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 2, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 2, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 2, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 3, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 3, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 3, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 3, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 3, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 3, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 4, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 4, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 4, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 4, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 4, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 4, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 5, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 5, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 5, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 5, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 5, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 5, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 5, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 5, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 6, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 6, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 6, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 6, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 6, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 6, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 6, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 6, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 7, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 7, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 7, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 7, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 7, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 7, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 7, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 7, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 8, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 8, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 8, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 8, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 8, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 8, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 8, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 8, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 9, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 9, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 9, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 9, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 9, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 9, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 9, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 9, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 9, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 9, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 9, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 10, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 10, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 10, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 10, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 10, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 10, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 10, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 10, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 10, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 11, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 11, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 11, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 11, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 11, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 11, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 11, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 11, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 11, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 11, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 11, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 12, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 12, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 12, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 12, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 12, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 12, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 12, 60},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 12, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 12, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 12, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 12, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 13, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 13, 64},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 13, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 13, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 13, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 13, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 13, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 1, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 1, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 1, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 1, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 1, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 1, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 1, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 1, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 1, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 1, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 1, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 2, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 2, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 2, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 2, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 2, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 2, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 2, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 2, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 2, 68},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 2, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 2, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 3, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 3, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 3, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 3, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 3, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 3, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 3, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 3, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 3, 72},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 3, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 3, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 4, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 4, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 4, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 4, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 4, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 4, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 4, 76},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 4, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 4, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 5, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 5, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 5, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 5, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 5, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 5, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 5, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 5, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 5, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 6, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 6, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 6, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 6, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 6, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 6, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 6, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 6, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 6, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 7, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 7, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 7, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 7, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 7, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 7, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 7, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 7, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 7, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 8, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 8, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 8, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 8, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 8, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 8, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 8, 78},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 8, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 8, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 9, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 9, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 9, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 9, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 9, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 9, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 9, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 9, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 9, 74},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 9, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 9, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 10, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 10, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 10, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 10, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 10, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 10, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 10, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 10, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 10, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 10, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 10, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 11, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 11, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 11, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 11, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 11, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 11, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 11, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 11, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 11, 70},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 11, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 11, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 12, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 12, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 12, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 12, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 12, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 12, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 12, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 12, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 12, 48},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 12, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 12, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 13, 26},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 13, 52},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 13, 26},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 13, 56},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 13, 26},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 13, 26},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 13, 40},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 14, 127},
	{PW_LMT_BAND_2_4G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 14, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 36, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 36, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 36, 26},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 36, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 36, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 36, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 36, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 36, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 36, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 36, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 40, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 40, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 40, 26},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 40, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 40, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 40, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 40, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 40, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 40, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 40, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 44, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 44, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 44, 26},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 44, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 44, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 44, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 44, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 44, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 44, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 44, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 48, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 48, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 48, 26},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 48, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 48, 20},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 48, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 48, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 48, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 48, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 48, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 48, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 52, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 52, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 52, 26},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 52, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 52, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 52, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 52, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 52, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 52, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 52, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 56, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 56, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 56, 26},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 56, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 56, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 56, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 56, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 56, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 56, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 56, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 60, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 60, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 60, 26},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 60, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 60, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 60, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 60, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 60, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 60, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 60, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 64, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 64, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 64, 26},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 64, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 64, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 64, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 64, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 64, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 64, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 64, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 100, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 100, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 100, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 100, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 100, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 100, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 100, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 100, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 100, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 100, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 104, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 104, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 104, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 104, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 104, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 104, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 104, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 104, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 104, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 104, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 108, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 108, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 108, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 108, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 108, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 108, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 108, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 108, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 108, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 108, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 112, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 112, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 112, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 112, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 112, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 112, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 112, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 112, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 112, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 112, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 116, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 116, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 116, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 116, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 116, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 116, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 116, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 116, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 116, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 116, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 120, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 120, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 120, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 120, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 120, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 120, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 120, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 120, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 124, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 124, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 124, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 124, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 124, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 124, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 124, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 124, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 128, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 128, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 128, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 128, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 128, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 128, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 128, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 128, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 132, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 132, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 132, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 132, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 132, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 132, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 132, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 132, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 132, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 132, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 136, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 136, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 136, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 136, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 136, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 136, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 136, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 136, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 136, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 136, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 140, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 140, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 140, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 140, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 140, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 140, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 140, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 140, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 140, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 140, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 144, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 144, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 144, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 144, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 144, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 144, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 144, 48},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 149, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 149, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 149, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 149, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 153, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 153, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 153, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 153, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 157, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 157, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 157, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 157, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 161, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 161, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 161, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 161, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 165, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 165, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 165, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 165, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 36, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 36, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 36, 14},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 36, 8},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 36, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 36, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 36, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 36, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 36, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 36, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 36, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 40, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 40, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 40, 14},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 40, 8},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 40, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 40, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 40, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 40, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 40, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 40, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 40, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 44, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 44, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 44, 14},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 44, 8},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 44, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 44, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 44, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 44, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 44, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 44, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 44, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 48, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 48, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 48, 14},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 48, 8},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 48, 4},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 48, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 48, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 48, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 48, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 48, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 48, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 52, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 52, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 52, 14},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 52, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 52, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 52, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 52, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 52, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 52, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 52, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 52, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 56, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 56, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 56, 14},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 56, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 56, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 56, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 56, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 56, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 56, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 56, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 56, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 60, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 60, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 60, 14},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 60, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 60, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 60, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 60, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 60, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 60, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 60, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 60, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 64, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 64, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 64, 14},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 64, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 64, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 64, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 64, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 64, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 64, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 64, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 64, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 100, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 100, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 100, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 100, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 100, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 100, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 100, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 100, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 100, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 100, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 100, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 104, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 104, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 104, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 104, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 104, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 104, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 104, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 104, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 104, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 104, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 104, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 108, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 108, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 108, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 108, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 108, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 108, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 108, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 108, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 108, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 108, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 108, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 112, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 112, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 112, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 112, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 112, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 112, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 112, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 112, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 112, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 112, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 112, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 116, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 116, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 116, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 116, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 116, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 116, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 116, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 116, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 116, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 116, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 116, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 120, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 120, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 120, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 120, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 120, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 120, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 120, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 120, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 124, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 124, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 124, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 124, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 124, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 124, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 124, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 124, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 128, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 128, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 128, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 128, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 128, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 128, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 128, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 128, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 132, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 132, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 132, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 132, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 132, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 132, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 132, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 132, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 132, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 132, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 132, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 136, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 136, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 136, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 136, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 136, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 136, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 136, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 136, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 136, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 136, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 136, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 140, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 140, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 140, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 140, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 140, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 140, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 140, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 140, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 140, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 140, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 140, 12},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 144, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 144, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 144, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 144, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 144, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 144, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 144, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 149, 72},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 149, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 149, 72},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 149, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 149, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 149, 72},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 149, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 153, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 153, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 153, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 153, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 157, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 157, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 157, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 157, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 161, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 161, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 161, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 161, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 165, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 165, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 165, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 165, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU26, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 36, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 36, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 36, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 36, 34},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 36, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 36, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 36, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 36, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 36, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 36, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 36, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 40, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 40, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 40, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 40, 34},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 40, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 40, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 40, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 40, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 40, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 40, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 40, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 44, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 44, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 44, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 44, 34},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 44, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 44, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 44, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 44, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 44, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 44, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 44, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 48, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 48, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 48, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 48, 34},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 48, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 48, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 48, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 48, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 48, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 48, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 48, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 52, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 52, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 52, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 52, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 52, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 52, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 52, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 52, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 52, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 52, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 52, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 56, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 56, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 56, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 56, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 56, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 56, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 56, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 56, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 56, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 56, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 56, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 60, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 60, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 60, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 60, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 60, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 60, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 60, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 60, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 60, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 60, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 60, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 64, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 64, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 64, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 64, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 64, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 64, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 64, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 64, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 64, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 64, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 64, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 100, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 100, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 100, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 100, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 100, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 100, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 100, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 100, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 100, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 100, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 100, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 104, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 104, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 104, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 104, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 104, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 104, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 104, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 104, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 104, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 104, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 104, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 108, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 108, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 108, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 108, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 108, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 108, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 108, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 108, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 108, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 108, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 108, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 112, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 112, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 112, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 112, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 112, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 112, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 112, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 112, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 112, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 112, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 112, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 116, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 116, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 116, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 116, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 116, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 116, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 116, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 116, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 116, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 116, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 116, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 120, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 120, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 120, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 120, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 120, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 120, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 120, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 120, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 124, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 124, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 124, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 124, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 124, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 124, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 124, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 124, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 128, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 128, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 128, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 128, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 128, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 128, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 128, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 128, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 132, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 132, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 132, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 132, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 132, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 132, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 132, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 132, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 132, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 132, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 132, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 136, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 136, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 136, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 136, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 136, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 136, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 136, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 136, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 136, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 136, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 136, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 140, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 140, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 140, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 140, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 140, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 140, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 140, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 140, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 140, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 140, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 140, 36},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 144, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 144, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 144, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 144, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 144, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 144, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 144, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 149, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 149, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 149, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 149, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 153, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 153, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 153, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 153, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 157, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 157, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 157, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 157, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 161, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 161, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 161, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 161, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 165, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 165, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 165, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 165, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 36, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 36, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 36, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 36, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 36, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 36, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 36, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 36, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 36, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 40, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 40, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 40, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 40, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 40, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 40, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 40, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 40, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 40, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 44, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 44, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 44, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 44, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 44, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 44, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 44, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 44, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 44, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 48, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 48, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 48, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 48, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 48, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 48, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 48, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 48, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 48, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 52, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 52, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 52, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 52, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 52, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 52, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 52, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 52, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 56, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 56, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 56, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 56, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 56, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 56, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 56, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 56, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 60, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 60, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 60, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 60, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 60, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 60, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 60, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 60, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 64, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 64, 24},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 64, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 64, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 64, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 64, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 64, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 64, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 100, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 100, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 100, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 100, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 100, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 100, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 100, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 104, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 104, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 104, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 104, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 104, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 104, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 104, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 108, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 108, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 108, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 108, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 108, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 108, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 108, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 112, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 112, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 112, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 112, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 112, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 112, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 112, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 116, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 116, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 116, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 116, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 116, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 116, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 116, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 120, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 120, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 120, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 120, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 120, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 120, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 120, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 120, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 124, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 124, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 124, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 124, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 124, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 124, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 124, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 124, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 128, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 128, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 128, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 128, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 128, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 128, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 128, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 128, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 132, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 132, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 132, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 132, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 132, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 132, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 132, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 136, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 136, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 136, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 136, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 136, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 136, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 136, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 140, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 140, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 140, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 140, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 140, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 140, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 140, 22},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 144, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 144, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 144, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 144, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 144, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 144, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 144, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 149, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 149, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 149, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 149, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 149, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 149, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 149, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 153, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 153, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 153, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 153, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 157, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 157, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 157, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 157, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 161, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 161, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 161, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 161, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 165, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 165, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 165, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 165, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU52, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 36, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 36, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 36, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 36, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 36, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 36, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 40, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 40, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 40, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 40, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 40, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 40, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 44, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 44, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 44, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 44, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 44, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 44, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 48, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 48, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 48, 44},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 48, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 48, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 48, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 52, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 52, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 52, 66},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 52, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 52, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 52, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 52, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 56, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 56, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 56, 66},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 56, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 56, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 56, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 56, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 60, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 60, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 60, 66},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 60, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 60, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 60, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 60, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 64, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 64, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 64, 66},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 64, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 64, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 64, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 64, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 100, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 100, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 100, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 100, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 100, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 100, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 100, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 100, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 104, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 104, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 104, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 104, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 104, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 104, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 104, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 104, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 108, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 108, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 108, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 108, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 108, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 108, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 108, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 108, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 112, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 112, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 112, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 112, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 112, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 112, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 112, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 112, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 116, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 116, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 116, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 116, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 116, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 116, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 116, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 116, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 120, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 120, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 120, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 120, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 120, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 120, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 120, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 120, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 124, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 124, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 124, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 124, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 124, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 124, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 124, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 124, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 128, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 128, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 128, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 128, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 128, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 128, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 128, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 128, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 132, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 132, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 132, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 132, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 132, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 132, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 132, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 132, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 136, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 136, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 136, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 136, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 136, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 136, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 136, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 136, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 140, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 140, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 140, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 140, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 140, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 140, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 140, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 140, 46},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 144, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 144, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 144, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 144, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 144, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 144, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 144, 74},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 149, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 149, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 149, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 149, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 153, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 153, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 153, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 153, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 157, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 157, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 157, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 157, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 161, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 161, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 161, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 161, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 165, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 165, 70},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 165, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_1T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 165, 28},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 36, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 36, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 36, 38},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 36, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 36, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 36, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 36, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 36, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 36, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 36, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 36, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 40, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 40, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 40, 38},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 40, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 40, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 40, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 40, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 40, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 40, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 40, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 40, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 44, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 44, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 44, 38},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 44, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 44, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 44, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 44, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 44, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 44, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 44, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 44, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 48, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 48, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 48, 38},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 48, 30},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 48, 26},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 48, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 48, 18},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 48, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 48, 50},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 48, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 48, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 52, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 52, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 52, 38},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 52, 52},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 52, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 52, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 52, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 52, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 52, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 52, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 52, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 56, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 56, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 56, 38},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 56, 52},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 56, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 56, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 56, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 56, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 56, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 56, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 56, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 60, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 60, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 60, 38},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 60, 52},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 60, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 60, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 60, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 60, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 60, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 60, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 60, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 64, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 64, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 64, 38},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 64, 52},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 64, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 64, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 64, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 64, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 64, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 64, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 64, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 100, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 100, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 100, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 100, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 100, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 100, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 100, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 100, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 100, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 100, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 100, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 104, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 104, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 104, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 104, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 104, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 104, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 104, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 104, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 104, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 104, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 104, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 108, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 108, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 108, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 108, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 108, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 108, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 108, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 108, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 108, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 108, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 108, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 112, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 112, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 112, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 112, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 112, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 112, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 112, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 112, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 112, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 112, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 112, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 116, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 116, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 116, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 116, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 116, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 116, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 116, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 116, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 116, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 116, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 116, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 120, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 120, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 120, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 120, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 120, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 120, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 120, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 120, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 120, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 124, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 124, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 124, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 124, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 124, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 124, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 124, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 124, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 124, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 128, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 128, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 128, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 128, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 128, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 128, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 128, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 128, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 128, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 132, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 132, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 132, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 132, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 132, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 132, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 132, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 132, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 132, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 132, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 132, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 136, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 136, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 136, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 136, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 136, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 136, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 136, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 136, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 136, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 136, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 136, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 140, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 140, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 140, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 140, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 140, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 140, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 140, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 140, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 140, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 140, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 140, 32},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 144, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 144, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 144, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 144, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 144, 62},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 144, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 144, 58},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 144, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 149, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 149, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 149, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 149, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 149, 64},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 149, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 153, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 153, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 153, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 153, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 153, 64},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 153, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 157, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 157, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 157, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 157, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 157, 64},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 157, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 161, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 161, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 161, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 161, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 161, 64},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 161, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_FCC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ETSI, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MKK, 165, 127},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_IC, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_KCC, 165, 54},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_ACMA, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CHILE, 165, 42},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_UKRAINE, 165, 16},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_MEXICO, 165, 76},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_CN, 165, 64},
	{PW_LMT_BAND_5G, PW_LMT_RU_BW_RU106, PW_LMT_PH_2T, PW_LMT_RS_HE, PW_LMT_REGU_NULL, 165, 16}
};


/******************************************************************************
 *                           txpwr_tracktssi.TXT
 ******************************************************************************/

const u8 delta_swingidx_mp_5gb_n_txpwrtrkssi_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3,
	 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
};

const u8 delta_swingidx_mp_5gb_p_txpwrtrkssi_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 5, 5,
	 5, 6, 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9},
	{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 4,
	 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4,
	 4, 5, 5, 5, 5, 6, 6, 6, 7, 7, 7, 7, 8, 8},
};

const u8 delta_swingidx_mp_5ga_n_txpwrtrkssi_8852a[][D_S_SIZE] = {
	{0, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 7,
	 7, 7, 8, 8, 9, 9, 9, 10, 10, 10, 11, 11, 12},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 2, 2, 3, 3, 4, 4, 5, 6, 6, 7, 7, 8, 8, 9, 10, 10,
	 11, 11, 12, 13, 13, 14, 14, 15, 15, 16, 17, 17},
};

const u8 delta_swingidx_mp_5ga_p_txpwrtrkssi_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 6, 6,
	 6, 7, 7, 7, 8, 8, 8, 9, 9, 10, 10, 10, 11, 11},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4,
	 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8},
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3,
	 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5},
};

const u8 delta_swingidx_mp_2gb_n_txpwrtrkssi_8852a[]    = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2gb_p_txpwrtrkssi_8852a[]    = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2ga_n_txpwrtrkssi_8852a[]    = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2ga_p_txpwrtrkssi_8852a[]    = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};
const u8 delta_swingidx_mp_2g_cck_b_n_txpwrtrkssi_8852a[] = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2g_cck_b_p_txpwrtrkssi_8852a[] = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2g_cck_a_n_txpwrtrkssi_8852a[] = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2g_cck_a_p_txpwrtrkssi_8852a[] = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};

/******************************************************************************
 *                           txpwr_tracktssi_type2.TXT
 ******************************************************************************/

const u8 delta_swingidx_mp_5gb_n_txpwrtrkssi_type2_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3,
	 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
};

const u8 delta_swingidx_mp_5gb_p_txpwrtrkssi_type2_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 5, 5,
	 5, 6, 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9},
	{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 4,
	 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4,
	 4, 5, 5, 5, 5, 6, 6, 6, 7, 7, 7, 7, 8, 8},
};

const u8 delta_swingidx_mp_5ga_n_txpwrtrkssi_type2_8852a[][D_S_SIZE] = {
	{0, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 7,
	 7, 7, 8, 8, 9, 9, 9, 10, 10, 10, 11, 11, 12},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 2, 2, 3, 3, 4, 4, 5, 6, 6, 7, 7, 8, 8, 9, 10, 10,
	 11, 11, 12, 13, 13, 14, 14, 15, 15, 16, 17, 17},
};

const u8 delta_swingidx_mp_5ga_p_txpwrtrkssi_type2_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 6, 6,
	 6, 7, 7, 7, 8, 8, 8, 9, 9, 10, 10, 10, 11, 11},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4,
	 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8},
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3,
	 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5},
};

const u8 delta_swingidx_mp_2gb_n_txpwrtrkssi_type2_8852a[]    = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2gb_p_txpwrtrkssi_type2_8852a[]    = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2ga_n_txpwrtrkssi_type2_8852a[]    = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2ga_p_txpwrtrkssi_type2_8852a[]    = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};
const u8 delta_swingidx_mp_2g_cck_b_n_txpwrtrkssi_type2_8852a[] = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2g_cck_b_p_txpwrtrkssi_type2_8852a[] = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2g_cck_a_n_txpwrtrkssi_type2_8852a[] = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2g_cck_a_p_txpwrtrkssi_type2_8852a[] = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};

/******************************************************************************
 *                           txpwr_tracktssi_type3.TXT
 ******************************************************************************/

const u8 delta_swingidx_mp_5gb_n_txpwrtrkssi_type3_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3,
	 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
};

const u8 delta_swingidx_mp_5gb_p_txpwrtrkssi_type3_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 5, 5,
	 5, 6, 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9},
	{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 4,
	 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4,
	 4, 5, 5, 5, 5, 6, 6, 6, 7, 7, 7, 7, 8, 8},
};

const u8 delta_swingidx_mp_5ga_n_txpwrtrkssi_type3_8852a[][D_S_SIZE] = {
	{0, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 7,
	 7, 7, 8, 8, 9, 9, 9, 10, 10, 10, 11, 11, 12},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 2, 2, 3, 3, 4, 4, 5, 6, 6, 7, 7, 8, 8, 9, 10, 10,
	 11, 11, 12, 13, 13, 14, 14, 15, 15, 16, 17, 17},
};

const u8 delta_swingidx_mp_5ga_p_txpwrtrkssi_type3_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 6, 6,
	 6, 7, 7, 7, 8, 8, 8, 9, 9, 10, 10, 10, 11, 11},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4,
	 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8},
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3,
	 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5},
};

const u8 delta_swingidx_mp_2gb_n_txpwrtrkssi_type3_8852a[]    = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2gb_p_txpwrtrkssi_type3_8852a[]    = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2ga_n_txpwrtrkssi_type3_8852a[]    = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2ga_p_txpwrtrkssi_type3_8852a[]    = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};
const u8 delta_swingidx_mp_2g_cck_b_n_txpwrtrkssi_type3_8852a[] = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2g_cck_b_p_txpwrtrkssi_type3_8852a[] = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2g_cck_a_n_txpwrtrkssi_type3_8852a[] = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2g_cck_a_p_txpwrtrkssi_type3_8852a[] = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};

/******************************************************************************
 *                           txpwr_tracktssi_type37.TXT
 ******************************************************************************/

const u8 delta_swingidx_mp_5gb_n_txpwrtrkssi_type37_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3,
	 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
};

const u8 delta_swingidx_mp_5gb_p_txpwrtrkssi_type37_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 5, 5,
	 5, 6, 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9},
	{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 4,
	 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4,
	 4, 5, 5, 5, 5, 6, 6, 6, 7, 7, 7, 7, 8, 8},
};

const u8 delta_swingidx_mp_5ga_n_txpwrtrkssi_type37_8852a[][D_S_SIZE] = {
	{0, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 7,
	 7, 7, 8, 8, 9, 9, 9, 10, 10, 10, 11, 11, 12},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 2, 2, 3, 3, 4, 4, 5, 6, 6, 7, 7, 8, 8, 9, 10, 10,
	 11, 11, 12, 13, 13, 14, 14, 15, 15, 16, 17, 17},
};

const u8 delta_swingidx_mp_5ga_p_txpwrtrkssi_type37_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 6, 6,
	 6, 7, 7, 7, 8, 8, 8, 9, 9, 10, 10, 10, 11, 11},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4,
	 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8},
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3,
	 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5},
};

const u8 delta_swingidx_mp_2gb_n_txpwrtrkssi_type37_8852a[]    = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2gb_p_txpwrtrkssi_type37_8852a[]    = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2ga_n_txpwrtrkssi_type37_8852a[]    = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2ga_p_txpwrtrkssi_type37_8852a[]    = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};
const u8 delta_swingidx_mp_2g_cck_b_n_txpwrtrkssi_type37_8852a[] = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2g_cck_b_p_txpwrtrkssi_type37_8852a[] = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2g_cck_a_n_txpwrtrkssi_type37_8852a[] = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2g_cck_a_p_txpwrtrkssi_type37_8852a[] = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};

/******************************************************************************
 *                           txpwr_tracktssi_type38.TXT
 ******************************************************************************/

const u8 delta_swingidx_mp_5gb_n_txpwrtrkssi_type38_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3,
	 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
};

const u8 delta_swingidx_mp_5gb_p_txpwrtrkssi_type38_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 5, 5,
	 5, 6, 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9},
	{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 4,
	 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4,
	 4, 5, 5, 5, 5, 6, 6, 6, 7, 7, 7, 7, 8, 8},
};

const u8 delta_swingidx_mp_5ga_n_txpwrtrkssi_type38_8852a[][D_S_SIZE] = {
	{0, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 7,
	 7, 7, 8, 8, 9, 9, 9, 10, 10, 10, 11, 11, 12},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 2, 2, 3, 3, 4, 4, 5, 6, 6, 7, 7, 8, 8, 9, 10, 10,
	 11, 11, 12, 13, 13, 14, 14, 15, 15, 16, 17, 17},
};

const u8 delta_swingidx_mp_5ga_p_txpwrtrkssi_type38_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 6, 6,
	 6, 7, 7, 7, 8, 8, 8, 9, 9, 10, 10, 10, 11, 11},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4,
	 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8},
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3,
	 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5},
};

const u8 delta_swingidx_mp_2gb_n_txpwrtrkssi_type38_8852a[]    = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2gb_p_txpwrtrkssi_type38_8852a[]    = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2ga_n_txpwrtrkssi_type38_8852a[]    = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2ga_p_txpwrtrkssi_type38_8852a[]    = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};
const u8 delta_swingidx_mp_2g_cck_b_n_txpwrtrkssi_type38_8852a[] = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2g_cck_b_p_txpwrtrkssi_type38_8852a[] = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2g_cck_a_n_txpwrtrkssi_type38_8852a[] = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2g_cck_a_p_txpwrtrkssi_type38_8852a[] = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};

/******************************************************************************
 *                           txpwr_tracktssi_type4.TXT
 ******************************************************************************/

const u8 delta_swingidx_mp_5gb_n_txpwrtrkssi_type4_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3,
	 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
};

const u8 delta_swingidx_mp_5gb_p_txpwrtrkssi_type4_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 5, 5,
	 5, 6, 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9},
	{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 4,
	 4, 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4,
	 4, 5, 5, 5, 5, 6, 6, 6, 7, 7, 7, 7, 8, 8},
};

const u8 delta_swingidx_mp_5ga_n_txpwrtrkssi_type4_8852a[][D_S_SIZE] = {
	{0, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 7,
	 7, 7, 8, 8, 9, 9, 9, 10, 10, 10, 11, 11, 12},
	{0, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 7,
	 8, 8, 9, 9, 10, 10, 11, 11, 11, 12, 12, 13, 13},
	{0, 1, 2, 2, 3, 3, 4, 4, 5, 6, 6, 7, 7, 8, 8, 9, 10, 10,
	 11, 11, 12, 13, 13, 14, 14, 15, 15, 16, 17, 17},
};

const u8 delta_swingidx_mp_5ga_p_txpwrtrkssi_type4_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 6, 6,
	 6, 7, 7, 7, 8, 8, 8, 9, 9, 10, 10, 10, 11, 11},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4,
	 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8},
	{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3,
	 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5},
};

const u8 delta_swingidx_mp_2gb_n_txpwrtrkssi_type4_8852a[]    = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2gb_p_txpwrtrkssi_type4_8852a[]    = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2ga_n_txpwrtrkssi_type4_8852a[]    = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2ga_p_txpwrtrkssi_type4_8852a[]    = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};
const u8 delta_swingidx_mp_2g_cck_b_n_txpwrtrkssi_type4_8852a[] = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2g_cck_b_p_txpwrtrkssi_type4_8852a[] = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2g_cck_a_n_txpwrtrkssi_type4_8852a[] = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2g_cck_a_p_txpwrtrkssi_type4_8852a[] = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};

/******************************************************************************
 *                           txpwr_tracktssi_type50.TXT
 ******************************************************************************/

const u8 delta_swingidx_mp_5gb_n_txpwrtrkssi_type50_8852a[][D_S_SIZE] = {
	{0, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 7,
	 7, 7, 8, 8, 9, 9, 9, 10, 10, 10, 11, 11, 11},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4,
	 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8},
	{0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 5, 5,
	 5, 6, 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9},
};

const u8 delta_swingidx_mp_5gb_p_txpwrtrkssi_type50_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 6, 6,
	 6, 7, 7, 7, 8, 8, 8, 9, 9, 10, 10, 10, 11, 11},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4,
	 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8},
	{0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 5, 5,
	 5, 6, 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9},
};

const u8 delta_swingidx_mp_5ga_n_txpwrtrkssi_type50_8852a[][D_S_SIZE] = {
	{0, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 5, 5, 5, 6, 6, 7,
	 7, 7, 8, 8, 9, 9, 9, 10, 10, 10, 11, 11, 11},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4,
	 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8},
	{0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 5, 5,
	 5, 6, 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9},
};

const u8 delta_swingidx_mp_5ga_p_txpwrtrkssi_type50_8852a[][D_S_SIZE] = {
	{0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 6, 6,
	 6, 7, 7, 7, 8, 8, 8, 9, 9, 10, 10, 10, 11, 11},
	{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 4, 4, 4, 4,
	 5, 5, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 8, 8},
	{0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 5, 5,
	 5, 6, 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9},
};

const u8 delta_swingidx_mp_2gb_n_txpwrtrkssi_type50_8852a[]    = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2gb_p_txpwrtrkssi_type50_8852a[]    = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2ga_n_txpwrtrkssi_type50_8852a[]    = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2ga_p_txpwrtrkssi_type50_8852a[]    = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};
const u8 delta_swingidx_mp_2g_cck_b_n_txpwrtrkssi_type50_8852a[] = {
	0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4,
	 4, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 7, 7};
const u8 delta_swingidx_mp_2g_cck_b_p_txpwrtrkssi_type50_8852a[] = {
	0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2,
	 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3};
const u8 delta_swingidx_mp_2g_cck_a_n_txpwrtrkssi_type50_8852a[] = {
	0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3,
	 3, 3, 3, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5};
const u8 delta_swingidx_mp_2g_cck_a_p_txpwrtrkssi_type50_8852a[] = {
	0, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 4, 5, 5, 5,
	 6, 6, 6, 7, 7, 7, 8, 8, 8, 9, 9, 9, 10, 10};

/******************************************************************************
 *                           txpwr_tracktssi_type51.TXT
 ******************************************************************************/

const u8 delta_swingidx_mp_5gb_n_txpwrtrkssi_type51_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5gb_p_txpwrtrkssi_type51_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5ga_n_txpwrtrkssi_type51_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5ga_p_txpwrtrkssi_type51_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_2gb_n_txpwrtrkssi_type51_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2gb_p_txpwrtrkssi_type51_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2ga_n_txpwrtrkssi_type51_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2ga_p_txpwrtrkssi_type51_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_b_n_txpwrtrkssi_type51_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_b_p_txpwrtrkssi_type51_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_a_n_txpwrtrkssi_type51_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_a_p_txpwrtrkssi_type51_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

/******************************************************************************
 *                           txpwr_tracktssi_type52.TXT
 ******************************************************************************/

const u8 delta_swingidx_mp_5gb_n_txpwrtrkssi_type52_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5gb_p_txpwrtrkssi_type52_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5ga_n_txpwrtrkssi_type52_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5ga_p_txpwrtrkssi_type52_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_2gb_n_txpwrtrkssi_type52_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2gb_p_txpwrtrkssi_type52_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2ga_n_txpwrtrkssi_type52_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2ga_p_txpwrtrkssi_type52_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_b_n_txpwrtrkssi_type52_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_b_p_txpwrtrkssi_type52_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_a_n_txpwrtrkssi_type52_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_a_p_txpwrtrkssi_type52_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

/******************************************************************************
 *                           txpwr_tracktssi_type53.TXT
 ******************************************************************************/

const u8 delta_swingidx_mp_5gb_n_txpwrtrkssi_type53_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5gb_p_txpwrtrkssi_type53_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5ga_n_txpwrtrkssi_type53_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5ga_p_txpwrtrkssi_type53_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_2gb_n_txpwrtrkssi_type53_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2gb_p_txpwrtrkssi_type53_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2ga_n_txpwrtrkssi_type53_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2ga_p_txpwrtrkssi_type53_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_b_n_txpwrtrkssi_type53_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_b_p_txpwrtrkssi_type53_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_a_n_txpwrtrkssi_type53_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_a_p_txpwrtrkssi_type53_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

/******************************************************************************
 *                           txpwr_tracktssi_type54.TXT
 ******************************************************************************/

const u8 delta_swingidx_mp_5gb_n_txpwrtrkssi_type54_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5gb_p_txpwrtrkssi_type54_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5ga_n_txpwrtrkssi_type54_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_5ga_p_txpwrtrkssi_type54_8852a[][D_S_SIZE] = {
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
};

const u8 delta_swingidx_mp_2gb_n_txpwrtrkssi_type54_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2gb_p_txpwrtrkssi_type54_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2ga_n_txpwrtrkssi_type54_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2ga_p_txpwrtrkssi_type54_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_b_n_txpwrtrkssi_type54_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_b_p_txpwrtrkssi_type54_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_a_n_txpwrtrkssi_type54_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const u8 delta_swingidx_mp_2g_cck_a_p_txpwrtrkssi_type54_8852a[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

/******************************************************************************
 *                           txxtaltrack.TXT
 ******************************************************************************/

const s8 delta_swing_xtal_mp_n_txxtaltrack_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
const s8 delta_swing_xtal_mp_p_txxtaltrack_8852a[]    = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, -5, -12, -18, -27, -28, -32, -32};

/******************************************************************************
 *                           txpwr_byrate.TXT
 ******************************************************************************/

const u32 array_mp_8852a_txpwr_byrate[] = {
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_11M_1M , 0x50505050,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_18M_6M , 0x50505050,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_54M_24M, 0x484c5050,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_MCS3_0 , 0x50505050,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_MCS7_4 , 0x44484c50,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_MCS11_8, 0x34383c40,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_DCM4_0 , 0x50505050,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_NSS2, PW_BYRATE_RATE_MCS3_0 , 0x50505050,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_NSS2, PW_BYRATE_RATE_MCS7_4 , 0x44484c50,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_NSS2, PW_BYRATE_RATE_MCS11_8, 0x34383c40,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_NSS2, PW_BYRATE_RATE_DCM4_0 , 0x50505050,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_OFFS, PW_BYRATE_RATE_AllRate2_1, 0x00000000,
	PW_LMT_BAND_2_4G, PW_BYRATE_PARA_OFFS, PW_BYRATE_RATE_AllRate2_2, 0x00000000,
	PW_LMT_BAND_5G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_18M_6M , 0x50505050,
	PW_LMT_BAND_5G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_54M_24M, 0x484c5050,
	PW_LMT_BAND_5G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_MCS3_0 , 0x50505050,
	PW_LMT_BAND_5G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_MCS7_4 , 0x44484c50,
	PW_LMT_BAND_5G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_MCS11_8, 0x34383c40,
	PW_LMT_BAND_5G, PW_BYRATE_PARA_NSS1, PW_BYRATE_RATE_DCM4_0 , 0x50505050,
	PW_LMT_BAND_5G, PW_BYRATE_PARA_NSS2, PW_BYRATE_RATE_MCS3_0 , 0x50505050,
	PW_LMT_BAND_5G, PW_BYRATE_PARA_NSS2, PW_BYRATE_RATE_MCS7_4 , 0x44484c50,
	PW_LMT_BAND_5G, PW_BYRATE_PARA_NSS2, PW_BYRATE_RATE_MCS11_8, 0x34383c40,
	PW_LMT_BAND_5G, PW_BYRATE_PARA_NSS2, PW_BYRATE_RATE_DCM4_0 , 0x50505050,
	PW_LMT_BAND_5G, PW_BYRATE_PARA_OFFS, PW_BYRATE_RATE_AllRate5_1, 0x00000000
};


#endif	/* _HALRF_HWIMG_RAW_DATA_8852A_H */